/* Plug.c generated by valac 0.36.4, the Vala compiler
 * generated from Plug.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2014 Switchboard Developers (http://launchpad.net/switchboard)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define SWITCHBOARD_TYPE_PLUG (switchboard_plug_get_type ())
#define SWITCHBOARD_PLUG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_PLUG, SwitchboardPlug))
#define SWITCHBOARD_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_PLUG, SwitchboardPlugClass))
#define SWITCHBOARD_IS_PLUG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_PLUG))
#define SWITCHBOARD_IS_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_PLUG))
#define SWITCHBOARD_PLUG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_PLUG, SwitchboardPlugClass))

typedef struct _SwitchboardPlug SwitchboardPlug;
typedef struct _SwitchboardPlugClass SwitchboardPlugClass;
typedef struct _SwitchboardPlugPrivate SwitchboardPlugPrivate;

#define SWITCHBOARD_PLUG_TYPE_CATEGORY (switchboard_plug_category_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SWITCHBOARD_PLUG_VISIBILITY_CHANGED_SIGNAL,
	SWITCHBOARD_PLUG_LAST_SIGNAL
};
static guint switchboard_plug_signals[SWITCHBOARD_PLUG_LAST_SIGNAL] = {0};

struct _SwitchboardPlug {
	GObject parent_instance;
	SwitchboardPlugPrivate * priv;
};

struct _SwitchboardPlugClass {
	GObjectClass parent_class;
	GtkWidget* (*get_widget) (SwitchboardPlug* self);
	void (*shown) (SwitchboardPlug* self);
	void (*hidden) (SwitchboardPlug* self);
	void (*search) (SwitchboardPlug* self, const gchar* search, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeTreeMap* (*search_finish) (SwitchboardPlug* self, GAsyncResult* _res_);
	void (*search_callback) (SwitchboardPlug* self, const gchar* location);
};

typedef enum  {
	SWITCHBOARD_PLUG_CATEGORY_PERSONAL = 0,
	SWITCHBOARD_PLUG_CATEGORY_HARDWARE = 1,
	SWITCHBOARD_PLUG_CATEGORY_NETWORK = 2,
	SWITCHBOARD_PLUG_CATEGORY_SYSTEM = 3,
	SWITCHBOARD_PLUG_CATEGORY_OTHER = 4
} SwitchboardPlugCategory;

struct _SwitchboardPlugPrivate {
	SwitchboardPlugCategory _category;
	gchar* _code_name;
	gchar* _display_name;
	gchar* _description;
	gchar* _icon;
	GeeTreeMap* _supported_settings;
	gboolean _can_show;
};


static gpointer switchboard_plug_parent_class = NULL;

GType switchboard_plug_get_type (void) G_GNUC_CONST;
GType switchboard_plug_category_get_type (void) G_GNUC_CONST;
#define SWITCHBOARD_PLUG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SWITCHBOARD_TYPE_PLUG, SwitchboardPlugPrivate))
enum  {
	SWITCHBOARD_PLUG_DUMMY_PROPERTY,
	SWITCHBOARD_PLUG_CATEGORY,
	SWITCHBOARD_PLUG_CODE_NAME,
	SWITCHBOARD_PLUG_DISPLAY_NAME,
	SWITCHBOARD_PLUG_DESCRIPTION,
	SWITCHBOARD_PLUG_ICON,
	SWITCHBOARD_PLUG_SUPPORTED_SETTINGS,
	SWITCHBOARD_PLUG_CAN_SHOW
};
#define SWITCHBOARD_PLUG_SEP "<sep>"
GtkWidget* switchboard_plug_get_widget (SwitchboardPlug* self);
static GtkWidget* switchboard_plug_real_get_widget (SwitchboardPlug* self);
void switchboard_plug_shown (SwitchboardPlug* self);
static void switchboard_plug_real_shown (SwitchboardPlug* self);
void switchboard_plug_hidden (SwitchboardPlug* self);
static void switchboard_plug_real_hidden (SwitchboardPlug* self);
void switchboard_plug_search (SwitchboardPlug* self, const gchar* search, GAsyncReadyCallback _callback_, gpointer _user_data_);
GeeTreeMap* switchboard_plug_search_finish (SwitchboardPlug* self, GAsyncResult* _res_);
void switchboard_plug_search_callback (SwitchboardPlug* self, const gchar* location);
static void switchboard_plug_real_search_callback (SwitchboardPlug* self, const gchar* location);
SwitchboardPlug* switchboard_plug_construct (GType object_type);
SwitchboardPlugCategory switchboard_plug_get_category (SwitchboardPlug* self);
static void switchboard_plug_set_category (SwitchboardPlug* self, SwitchboardPlugCategory value);
const gchar* switchboard_plug_get_code_name (SwitchboardPlug* self);
static void switchboard_plug_set_code_name (SwitchboardPlug* self, const gchar* value);
const gchar* switchboard_plug_get_display_name (SwitchboardPlug* self);
static void switchboard_plug_set_display_name (SwitchboardPlug* self, const gchar* value);
const gchar* switchboard_plug_get_description (SwitchboardPlug* self);
static void switchboard_plug_set_description (SwitchboardPlug* self, const gchar* value);
const gchar* switchboard_plug_get_icon (SwitchboardPlug* self);
static void switchboard_plug_set_icon (SwitchboardPlug* self, const gchar* value);
GeeTreeMap* switchboard_plug_get_supported_settings (SwitchboardPlug* self);
static void switchboard_plug_set_supported_settings (SwitchboardPlug* self, GeeTreeMap* value);
gboolean switchboard_plug_get_can_show (SwitchboardPlug* self);
void switchboard_plug_set_can_show (SwitchboardPlug* self, gboolean value);
static void switchboard_plug_finalize (GObject * obj);
static void _vala_switchboard_plug_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_switchboard_plug_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType switchboard_plug_category_get_type (void) {
	static volatile gsize switchboard_plug_category_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_plug_category_type_id__volatile)) {
		static const GEnumValue values[] = {{SWITCHBOARD_PLUG_CATEGORY_PERSONAL, "SWITCHBOARD_PLUG_CATEGORY_PERSONAL", "personal"}, {SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "SWITCHBOARD_PLUG_CATEGORY_HARDWARE", "hardware"}, {SWITCHBOARD_PLUG_CATEGORY_NETWORK, "SWITCHBOARD_PLUG_CATEGORY_NETWORK", "network"}, {SWITCHBOARD_PLUG_CATEGORY_SYSTEM, "SWITCHBOARD_PLUG_CATEGORY_SYSTEM", "system"}, {SWITCHBOARD_PLUG_CATEGORY_OTHER, "SWITCHBOARD_PLUG_CATEGORY_OTHER", "other"}, {0, NULL, NULL}};
		GType switchboard_plug_category_type_id;
		switchboard_plug_category_type_id = g_enum_register_static ("SwitchboardPlugCategory", values);
		g_once_init_leave (&switchboard_plug_category_type_id__volatile, switchboard_plug_category_type_id);
	}
	return switchboard_plug_category_type_id__volatile;
}


/**
     * Returns the widget that contain the whole interface.
     *
     * @return a {@link Gtk.Widget} containing the interface.
     */
static GtkWidget* switchboard_plug_real_get_widget (SwitchboardPlug* self) {
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_critical ("Type `%s' does not implement abstract method `switchboard_plug_get_widget'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return NULL;
#line 156 "Plug.c"
}


GtkWidget* switchboard_plug_get_widget (SwitchboardPlug* self) {
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return SWITCHBOARD_PLUG_GET_CLASS (self)->get_widget (self);
#line 165 "Plug.c"
}


/**
     * Called when the plug appears to the user.
     */
static void switchboard_plug_real_shown (SwitchboardPlug* self) {
#line 93 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_critical ("Type `%s' does not implement abstract method `switchboard_plug_shown'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 93 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return;
#line 177 "Plug.c"
}


void switchboard_plug_shown (SwitchboardPlug* self) {
#line 93 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 93 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	SWITCHBOARD_PLUG_GET_CLASS (self)->shown (self);
#line 186 "Plug.c"
}


/**
     * Called when the plug disappear to the user.
     * 
     * This is not called when the plug got destroyed or the window is closed, use ~Plug () instead.
     */
static void switchboard_plug_real_hidden (SwitchboardPlug* self) {
#line 100 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_critical ("Type `%s' does not implement abstract method `switchboard_plug_hidden'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 100 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return;
#line 200 "Plug.c"
}


void switchboard_plug_hidden (SwitchboardPlug* self) {
#line 100 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 100 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	SWITCHBOARD_PLUG_GET_CLASS (self)->hidden (self);
#line 209 "Plug.c"
}


void switchboard_plug_search (SwitchboardPlug* self, const gchar* search, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	SWITCHBOARD_PLUG_GET_CLASS (self)->search (self, search, _callback_, _user_data_);
#line 216 "Plug.c"
}


GeeTreeMap* switchboard_plug_search_finish (SwitchboardPlug* self, GAsyncResult* _res_) {
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return SWITCHBOARD_PLUG_GET_CLASS (self)->search_finish (self, _res_);
#line 223 "Plug.c"
}


/**
     * This function is used when the user click on a search result, it should show the selected setting (right tab…).
     * 
     * @param location a {@link string} that represents the setting to show.
     */
static void switchboard_plug_real_search_callback (SwitchboardPlug* self, const gchar* location) {
#line 117 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_critical ("Type `%s' does not implement abstract method `switchboard_plug_search_callback'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 117 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return;
#line 237 "Plug.c"
}


void switchboard_plug_search_callback (SwitchboardPlug* self, const gchar* location) {
#line 117 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 117 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	SWITCHBOARD_PLUG_GET_CLASS (self)->search_callback (self, location);
#line 246 "Plug.c"
}


SwitchboardPlug* switchboard_plug_construct (GType object_type) {
	SwitchboardPlug * self = NULL;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	self = (SwitchboardPlug*) g_object_new (object_type, NULL);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return self;
#line 256 "Plug.c"
}


SwitchboardPlugCategory switchboard_plug_get_category (SwitchboardPlug* self) {
	SwitchboardPlugCategory result;
	SwitchboardPlugCategory _tmp0_;
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_tmp0_ = self->priv->_category;
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	result = _tmp0_;
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return result;
#line 271 "Plug.c"
}


static void switchboard_plug_set_category (SwitchboardPlug* self, SwitchboardPlugCategory value) {
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	if (switchboard_plug_get_category (self) != value) {
#line 280 "Plug.c"
		SwitchboardPlugCategory _tmp0_;
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp0_ = value;
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		self->priv->_category = _tmp0_;
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_object_notify ((GObject *) self, "category");
#line 288 "Plug.c"
	}
}


const gchar* switchboard_plug_get_code_name (SwitchboardPlug* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_tmp0_ = self->priv->_code_name;
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	result = _tmp0_;
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return result;
#line 304 "Plug.c"
}


static void switchboard_plug_set_code_name (SwitchboardPlug* self, const gchar* value) {
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	if (g_strcmp0 (value, switchboard_plug_get_code_name (self)) != 0) {
#line 313 "Plug.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp0_ = value;
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_g_free0 (self->priv->_code_name);
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		self->priv->_code_name = _tmp1_;
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_object_notify ((GObject *) self, "code-name");
#line 326 "Plug.c"
	}
}


const gchar* switchboard_plug_get_display_name (SwitchboardPlug* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_tmp0_ = self->priv->_display_name;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	result = _tmp0_;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return result;
#line 342 "Plug.c"
}


static void switchboard_plug_set_display_name (SwitchboardPlug* self, const gchar* value) {
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	if (g_strcmp0 (value, switchboard_plug_get_display_name (self)) != 0) {
#line 351 "Plug.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp0_ = value;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_g_free0 (self->priv->_display_name);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		self->priv->_display_name = _tmp1_;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_object_notify ((GObject *) self, "display-name");
#line 364 "Plug.c"
	}
}


const gchar* switchboard_plug_get_description (SwitchboardPlug* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_tmp0_ = self->priv->_description;
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	result = _tmp0_;
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return result;
#line 380 "Plug.c"
}


static void switchboard_plug_set_description (SwitchboardPlug* self, const gchar* value) {
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	if (g_strcmp0 (value, switchboard_plug_get_description (self)) != 0) {
#line 389 "Plug.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp0_ = value;
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_g_free0 (self->priv->_description);
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		self->priv->_description = _tmp1_;
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_object_notify ((GObject *) self, "description");
#line 402 "Plug.c"
	}
}


const gchar* switchboard_plug_get_icon (SwitchboardPlug* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_tmp0_ = self->priv->_icon;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	result = _tmp0_;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return result;
#line 418 "Plug.c"
}


static void switchboard_plug_set_icon (SwitchboardPlug* self, const gchar* value) {
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	if (g_strcmp0 (value, switchboard_plug_get_icon (self)) != 0) {
#line 427 "Plug.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp0_ = value;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_g_free0 (self->priv->_icon);
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		self->priv->_icon = _tmp1_;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_object_notify ((GObject *) self, "icon");
#line 440 "Plug.c"
	}
}


GeeTreeMap* switchboard_plug_get_supported_settings (SwitchboardPlug* self) {
	GeeTreeMap* result;
	GeeTreeMap* _tmp0_;
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_tmp0_ = self->priv->_supported_settings;
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	result = _tmp0_;
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return result;
#line 456 "Plug.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 463 "Plug.c"
}


static void switchboard_plug_set_supported_settings (SwitchboardPlug* self, GeeTreeMap* value) {
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	if (switchboard_plug_get_supported_settings (self) != value) {
#line 472 "Plug.c"
		GeeTreeMap* _tmp0_;
		GeeTreeMap* _tmp1_;
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp0_ = value;
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_g_object_unref0 (self->priv->_supported_settings);
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		self->priv->_supported_settings = _tmp1_;
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_object_notify ((GObject *) self, "supported-settings");
#line 485 "Plug.c"
	}
}


gboolean switchboard_plug_get_can_show (SwitchboardPlug* self) {
	gboolean result;
	gboolean _tmp0_;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_tmp0_ = self->priv->_can_show;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	result = _tmp0_;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	return result;
#line 501 "Plug.c"
}


void switchboard_plug_set_can_show (SwitchboardPlug* self, gboolean value) {
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_return_if_fail (self != NULL);
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	if (switchboard_plug_get_can_show (self) != value) {
#line 510 "Plug.c"
		gboolean _tmp0_;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		_tmp0_ = value;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		self->priv->_can_show = _tmp0_;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_object_notify ((GObject *) self, "can-show");
#line 518 "Plug.c"
	}
}


static void switchboard_plug_class_init (SwitchboardPlugClass * klass) {
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	switchboard_plug_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_type_class_add_private (klass, sizeof (SwitchboardPlugPrivate));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug *)) switchboard_plug_real_get_widget;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug *)) switchboard_plug_real_shown;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug *)) switchboard_plug_real_hidden;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug *, const gchar*)) switchboard_plug_real_search_callback;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_switchboard_plug_get_property;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_switchboard_plug_set_property;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = switchboard_plug_finalize;
#line 542 "Plug.c"
	/**
	     * The category under which the plug will be stored.
	     * 
	     * Possible {@link Category} values are PERSONAL, HARDWARE, NETWORK or SYSTEM.
	     */
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_PLUG_CATEGORY, g_param_spec_enum ("category", "category", "category", SWITCHBOARD_PLUG_TYPE_CATEGORY, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 550 "Plug.c"
	/**
	     * The unique name representing the plug.
	     * 
	     * It is also used to recognise it with the open-plug command.
	     * for example "system-pantheon-info" for the official Info plug of the pantheon desktop.
	     */
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_PLUG_CODE_NAME, g_param_spec_string ("code-name", "code-name", "code-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 559 "Plug.c"
	/**
	     * The localised name of the plug.
	     */
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_PLUG_DISPLAY_NAME, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 565 "Plug.c"
	/**
	     * A short description of the plug.
	     */
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_PLUG_DESCRIPTION, g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 571 "Plug.c"
	/**
	     * The icon representing the plug.
	     */
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_PLUG_ICON, g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 577 "Plug.c"
	/**
	     * A map of settings:// endpoints and location to pass to the
	     * {@link search_callback} method if the value is not %NULL.
	     * For example {"input/keyboard", "keyboard"}.
	     */
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_PLUG_SUPPORTED_SETTINGS, g_param_spec_object ("supported-settings", "supported-settings", "supported-settings", GEE_TYPE_TREE_MAP, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 585 "Plug.c"
	/**
	     * Inform if the plug should be shown or not
	     */
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_PLUG_CAN_SHOW, g_param_spec_boolean ("can-show", "can-show", "can-show", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 591 "Plug.c"
	/**
	     * Inform the application that the plug can now be listed in the available plugs.
	     * The application will also listen to the notify::can-show signal.
	     */
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	switchboard_plug_signals[SWITCHBOARD_PLUG_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("visibility_changed", SWITCHBOARD_TYPE_PLUG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 598 "Plug.c"
}


static void switchboard_plug_instance_init (SwitchboardPlug * self) {
	GeeTreeMap* _tmp0_;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	self->priv = SWITCHBOARD_PLUG_GET_PRIVATE (self);
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	self->priv->_supported_settings = _tmp0_;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	self->priv->_can_show = TRUE;
#line 612 "Plug.c"
}


static void switchboard_plug_finalize (GObject * obj) {
	SwitchboardPlug * self;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_PLUG, SwitchboardPlug);
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_g_free0 (self->priv->_code_name);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_g_free0 (self->priv->_display_name);
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_g_free0 (self->priv->_description);
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_g_free0 (self->priv->_icon);
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	_g_object_unref0 (self->priv->_supported_settings);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	G_OBJECT_CLASS (switchboard_plug_parent_class)->finalize (obj);
#line 632 "Plug.c"
}


GType switchboard_plug_get_type (void) {
	static volatile gsize switchboard_plug_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_plug_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SwitchboardPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) switchboard_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SwitchboardPlug), 0, (GInstanceInitFunc) switchboard_plug_instance_init, NULL };
		GType switchboard_plug_type_id;
		switchboard_plug_type_id = g_type_register_static (G_TYPE_OBJECT, "SwitchboardPlug", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&switchboard_plug_type_id__volatile, switchboard_plug_type_id);
	}
	return switchboard_plug_type_id__volatile;
}


static void _vala_switchboard_plug_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SwitchboardPlug * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_TYPE_PLUG, SwitchboardPlug);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_CATEGORY:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_value_set_enum (value, switchboard_plug_get_category (self));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_CODE_NAME:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_value_set_string (value, switchboard_plug_get_code_name (self));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_DISPLAY_NAME:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_value_set_string (value, switchboard_plug_get_display_name (self));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_DESCRIPTION:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_value_set_string (value, switchboard_plug_get_description (self));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_ICON:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_value_set_string (value, switchboard_plug_get_icon (self));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_SUPPORTED_SETTINGS:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_value_set_object (value, switchboard_plug_get_supported_settings (self));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_CAN_SHOW:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		g_value_set_boolean (value, switchboard_plug_get_can_show (self));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 695 "Plug.c"
		default:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 701 "Plug.c"
	}
}


static void _vala_switchboard_plug_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SwitchboardPlug * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_TYPE_PLUG, SwitchboardPlug);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_CATEGORY:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		switchboard_plug_set_category (self, g_value_get_enum (value));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_CODE_NAME:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		switchboard_plug_set_code_name (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_DISPLAY_NAME:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		switchboard_plug_set_display_name (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_DESCRIPTION:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		switchboard_plug_set_description (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_ICON:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		switchboard_plug_set_icon (self, g_value_get_string (value));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_SUPPORTED_SETTINGS:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		switchboard_plug_set_supported_settings (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		case SWITCHBOARD_PLUG_CAN_SHOW:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		switchboard_plug_set_can_show (self, g_value_get_boolean (value));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 753 "Plug.c"
		default:
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/Plug.vala"
		break;
#line 759 "Plug.c"
	}
}



