/* PlugsManager.c generated by valac 0.36.4, the Vala compiler
 * generated from PlugsManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2014 Switchboard Developers (http://launchpad.net/switchboard)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include "config.h"
#include <stdlib.h>
#include <string.h>
#include <gmodule.h>


#define SWITCHBOARD_TYPE_PLUGS_MANAGER (switchboard_plugs_manager_get_type ())
#define SWITCHBOARD_PLUGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManager))
#define SWITCHBOARD_PLUGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManagerClass))
#define SWITCHBOARD_IS_PLUGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_PLUGS_MANAGER))
#define SWITCHBOARD_IS_PLUGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_PLUGS_MANAGER))
#define SWITCHBOARD_PLUGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManagerClass))

typedef struct _SwitchboardPlugsManager SwitchboardPlugsManager;
typedef struct _SwitchboardPlugsManagerClass SwitchboardPlugsManagerClass;
typedef struct _SwitchboardPlugsManagerPrivate SwitchboardPlugsManagerPrivate;

#define SWITCHBOARD_TYPE_PLUG (switchboard_plug_get_type ())
#define SWITCHBOARD_PLUG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_PLUG, SwitchboardPlug))
#define SWITCHBOARD_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_PLUG, SwitchboardPlugClass))
#define SWITCHBOARD_IS_PLUG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_PLUG))
#define SWITCHBOARD_IS_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_PLUG))
#define SWITCHBOARD_PLUG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_PLUG, SwitchboardPlugClass))

typedef struct _SwitchboardPlug SwitchboardPlug;
typedef struct _SwitchboardPlugClass SwitchboardPlugClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	SWITCHBOARD_PLUGS_MANAGER_PLUG_ADDED_SIGNAL,
	SWITCHBOARD_PLUGS_MANAGER_LAST_SIGNAL
};
static guint switchboard_plugs_manager_signals[SWITCHBOARD_PLUGS_MANAGER_LAST_SIGNAL] = {0};

struct _SwitchboardPlugsManager {
	GObject parent_instance;
	SwitchboardPlugsManagerPrivate * priv;
};

struct _SwitchboardPlugsManagerClass {
	GObjectClass parent_class;
};

struct _SwitchboardPlugsManagerPrivate {
	GeeLinkedList* plugs;
};

typedef SwitchboardPlug* (*SwitchboardPlugsManagerRegisterPluginFunction) (GModule* module);

static gpointer switchboard_plugs_manager_parent_class = NULL;
static SwitchboardPlugsManager* switchboard_plugs_manager_plugs_manager;
static SwitchboardPlugsManager* switchboard_plugs_manager_plugs_manager = NULL;

GType switchboard_plugs_manager_get_type (void) G_GNUC_CONST;
GType switchboard_plug_get_type (void) G_GNUC_CONST;
#define SWITCHBOARD_PLUGS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManagerPrivate))
enum  {
	SWITCHBOARD_PLUGS_MANAGER_DUMMY_PROPERTY
};
SwitchboardPlugsManager* switchboard_plugs_manager_get_default (void);
static SwitchboardPlugsManager* switchboard_plugs_manager_new (void);
static SwitchboardPlugsManager* switchboard_plugs_manager_construct (GType object_type);
static void switchboard_plugs_manager_find_plugins (SwitchboardPlugsManager* self, GFile* base_folder);
static void switchboard_plugs_manager_load (SwitchboardPlugsManager* self, const gchar* path);
static void switchboard_plugs_manager_register_plug (SwitchboardPlugsManager* self, SwitchboardPlug* plug);
const gchar* switchboard_plug_get_code_name (SwitchboardPlug* self);
gboolean switchboard_plugs_manager_has_plugs (SwitchboardPlugsManager* self);
GeeCollection* switchboard_plugs_manager_get_plugs (SwitchboardPlugsManager* self);
static void switchboard_plugs_manager_finalize (GObject * obj);


static gpointer _g_object_ref0 (gpointer self) {
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 105 "PlugsManager.c"
}


SwitchboardPlugsManager* switchboard_plugs_manager_get_default (void) {
	SwitchboardPlugsManager* result = NULL;
	SwitchboardPlugsManager* _tmp0_;
	SwitchboardPlugsManager* _tmp2_;
	SwitchboardPlugsManager* _tmp3_;
#line 26 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = switchboard_plugs_manager_plugs_manager;
#line 26 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp0_ == NULL) {
#line 118 "PlugsManager.c"
		SwitchboardPlugsManager* _tmp1_;
#line 27 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp1_ = switchboard_plugs_manager_new ();
#line 27 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_object_unref0 (switchboard_plugs_manager_plugs_manager);
#line 27 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		switchboard_plugs_manager_plugs_manager = _tmp1_;
#line 126 "PlugsManager.c"
	}
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp2_ = switchboard_plugs_manager_plugs_manager;
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	result = _tmp3_;
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return result;
#line 136 "PlugsManager.c"
}


static SwitchboardPlugsManager* switchboard_plugs_manager_construct (GType object_type) {
	SwitchboardPlugsManager * self = NULL;
	GeeLinkedList* _tmp0_;
	GFile* base_folder = NULL;
	GFile* _tmp1_;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	self = (SwitchboardPlugsManager*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = gee_linked_list_new (SWITCHBOARD_TYPE_PLUG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 39 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (self->priv->plugs);
#line 39 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	self->priv->plugs = _tmp0_;
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = g_file_new_for_path (PLUGS_DIR);
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	base_folder = _tmp1_;
#line 41 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	switchboard_plugs_manager_find_plugins (self, base_folder);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (base_folder);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return self;
#line 163 "PlugsManager.c"
}


static SwitchboardPlugsManager* switchboard_plugs_manager_new (void) {
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return switchboard_plugs_manager_construct (SWITCHBOARD_TYPE_PLUGS_MANAGER);
#line 170 "PlugsManager.c"
}


static void switchboard_plugs_manager_load (SwitchboardPlugsManager* self, const gchar* path) {
	gboolean _tmp0_;
	GModule* module = NULL;
	const gchar* _tmp1_;
	GModule* _tmp2_;
	GModule* _tmp3_;
	void* function = NULL;
	GModule* _tmp5_;
	void* _tmp6_ = NULL;
	void* _tmp7_;
	SwitchboardPlugsManagerRegisterPluginFunction register_plugin = NULL;
	void* _tmp9_;
	SwitchboardPlug* plug = NULL;
	SwitchboardPlugsManagerRegisterPluginFunction _tmp10_;
	GModule* _tmp11_;
	SwitchboardPlug* _tmp12_;
	SwitchboardPlug* _tmp13_;
	GModule* _tmp15_;
	SwitchboardPlug* _tmp16_;
#line 44 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (path != NULL);
#line 45 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = g_module_supported ();
#line 45 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp0_ == FALSE) {
#line 46 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_error ("PlugsManager.vala:46: Switchboard is not supported by this system!");
#line 203 "PlugsManager.c"
	}
#line 49 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = path;
#line 49 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp2_ = g_module_open (_tmp1_, G_MODULE_BIND_LAZY);
#line 49 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	module = _tmp2_;
#line 50 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp3_ = module;
#line 50 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp3_ == NULL) {
#line 215 "PlugsManager.c"
		const gchar* _tmp4_;
#line 51 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp4_ = g_module_error ();
#line 51 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_critical ("PlugsManager.vala:51: %s", _tmp4_);
#line 52 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_module_close0 (module);
#line 52 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 225 "PlugsManager.c"
	}
#line 56 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp5_ = module;
#line 56 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_module_symbol (_tmp5_, "get_plug", &_tmp6_);
#line 56 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	function = _tmp6_;
#line 57 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp7_ = function;
#line 57 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp7_ == NULL) {
#line 237 "PlugsManager.c"
		const gchar* _tmp8_;
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp8_ = path;
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_critical ("PlugsManager.vala:58: get_plug () not found in %s", _tmp8_);
#line 59 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_module_close0 (module);
#line 59 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 247 "PlugsManager.c"
	}
#line 62 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp9_ = function;
#line 62 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	register_plugin = (SwitchboardPlugsManagerRegisterPluginFunction) _tmp9_;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp10_ = register_plugin;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp11_ = module;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp12_ = _tmp10_ (_tmp11_);
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	plug = _tmp12_;
#line 64 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp13_ = plug;
#line 64 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp13_ == NULL) {
#line 265 "PlugsManager.c"
		const gchar* _tmp14_;
#line 65 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp14_ = path;
#line 65 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_critical ("PlugsManager.vala:65: Unknown plugin type for %s !", _tmp14_);
#line 66 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_object_unref0 (plug);
#line 66 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_module_close0 (module);
#line 66 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 277 "PlugsManager.c"
	}
#line 68 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp15_ = module;
#line 68 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_module_make_resident (_tmp15_);
#line 69 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp16_ = plug;
#line 69 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	switchboard_plugs_manager_register_plug (self, _tmp16_);
#line 44 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (plug);
#line 44 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_module_close0 (module);
#line 291 "PlugsManager.c"
}


static void switchboard_plugs_manager_find_plugins (SwitchboardPlugsManager* self, GFile* base_folder) {
	GFileInfo* file_info = NULL;
	GError * _inner_error_ = NULL;
#line 72 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (self != NULL);
#line 72 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (base_folder != NULL);
#line 73 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	file_info = NULL;
#line 304 "PlugsManager.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp0_;
		GFileEnumerator* _tmp1_;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp0_ = base_folder;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp1_ = g_file_enumerate_children (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error_);
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		enumerator = _tmp1_;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 317 "PlugsManager.c"
			goto __catch0_g_error;
		}
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		while (TRUE) {
#line 322 "PlugsManager.c"
			GFileInfo* _tmp2_ = NULL;
			GFileEnumerator* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			GFile* file = NULL;
			GFile* _tmp7_;
			GFileInfo* _tmp8_;
			const gchar* _tmp9_;
			GFile* _tmp10_;
			gboolean _tmp11_ = FALSE;
			GFileInfo* _tmp12_;
			GFileType _tmp13_;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp3_ = enumerator;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error_);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp2_ = _tmp4_;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_g_object_unref0 (enumerator);
#line 346 "PlugsManager.c"
				goto __catch0_g_error;
			}
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp5_ = _tmp2_;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp2_ = NULL;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_g_object_unref0 (file_info);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			file_info = _tmp5_;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp6_ = file_info;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			if (!(_tmp6_ != NULL)) {
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_g_object_unref0 (_tmp2_);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				break;
#line 365 "PlugsManager.c"
			}
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp7_ = base_folder;
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp8_ = file_info;
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp9_ = g_file_info_get_name (_tmp8_);
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp10_ = g_file_get_child (_tmp7_, _tmp9_);
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			file = _tmp10_;
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp12_ = file_info;
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp13_ = g_file_info_get_file_type (_tmp12_);
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			if (_tmp13_ == G_FILE_TYPE_REGULAR) {
#line 383 "PlugsManager.c"
				GFileInfo* _tmp14_;
				const gchar* _tmp15_;
				gboolean _tmp16_;
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp14_ = file_info;
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp15_ = g_file_info_get_content_type (_tmp14_);
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp16_ = g_content_type_equals (_tmp15_, "application/x-sharedlib");
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp11_ = _tmp16_;
#line 395 "PlugsManager.c"
			} else {
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp11_ = FALSE;
#line 399 "PlugsManager.c"
			}
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			if (_tmp11_) {
#line 403 "PlugsManager.c"
				GFile* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp17_ = file;
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp18_ = g_file_get_path (_tmp17_);
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp19_ = _tmp18_;
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				switchboard_plugs_manager_load (self, _tmp19_);
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_g_free0 (_tmp19_);
#line 417 "PlugsManager.c"
			} else {
				GFileInfo* _tmp20_;
				GFileType _tmp21_;
#line 81 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp20_ = file_info;
#line 81 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp21_ = g_file_info_get_file_type (_tmp20_);
#line 81 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				if (_tmp21_ == G_FILE_TYPE_DIRECTORY) {
#line 427 "PlugsManager.c"
					GFile* _tmp22_;
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
					_tmp22_ = file;
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
					switchboard_plugs_manager_find_plugins (self, _tmp22_);
#line 433 "PlugsManager.c"
				}
			}
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_g_object_unref0 (file);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_g_object_unref0 (_tmp2_);
#line 440 "PlugsManager.c"
		}
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_object_unref0 (enumerator);
#line 444 "PlugsManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GFile* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GError* _tmp26_;
		const gchar* _tmp27_;
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		err = _inner_error_;
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_inner_error_ = NULL;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp23_ = base_folder;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp24_ = g_file_get_path (_tmp23_);
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp25_ = _tmp24_;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp26_ = err;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp27_ = _tmp26_->message;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_warning ("PlugsManager.vala:86: Unable to scan plugs folder %s: %s\n", _tmp25_, _tmp27_);
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_free0 (_tmp25_);
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_error_free0 (err);
#line 475 "PlugsManager.c"
	}
	__finally0:
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_object_unref0 (file_info);
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_clear_error (&_inner_error_);
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 488 "PlugsManager.c"
	}
#line 72 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (file_info);
#line 492 "PlugsManager.c"
}


static void switchboard_plugs_manager_register_plug (SwitchboardPlugsManager* self, SwitchboardPlug* plug) {
	SwitchboardPlug* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeLinkedList* _tmp3_;
	SwitchboardPlug* _tmp4_;
	gboolean _tmp5_;
	GeeLinkedList* _tmp6_;
	SwitchboardPlug* _tmp7_;
	SwitchboardPlug* _tmp8_;
#line 90 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (self != NULL);
#line 90 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (plug != NULL);
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = plug;
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = switchboard_plug_get_code_name (_tmp0_);
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp2_ = _tmp1_;
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_debug ("PlugsManager.vala:91: %s registered", _tmp2_);
#line 92 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp3_ = self->priv->plugs;
#line 92 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp4_ = plug;
#line 92 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp3_, _tmp4_);
#line 92 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp5_) {
#line 93 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 528 "PlugsManager.c"
	}
#line 94 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp6_ = self->priv->plugs;
#line 94 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp7_ = plug;
#line 94 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 95 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp8_ = plug;
#line 95 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_signal_emit (self, switchboard_plugs_manager_signals[SWITCHBOARD_PLUGS_MANAGER_PLUG_ADDED_SIGNAL], 0, _tmp8_);
#line 540 "PlugsManager.c"
}


gboolean switchboard_plugs_manager_has_plugs (SwitchboardPlugsManager* self) {
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 98 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = self->priv->plugs;
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp2_ = _tmp1_;
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	result = !_tmp2_;
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return result;
#line 561 "PlugsManager.c"
}


GeeCollection* switchboard_plugs_manager_get_plugs (SwitchboardPlugsManager* self) {
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 102 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = self->priv->plugs;
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp2_ = _tmp1_;
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	result = (GeeCollection*) _tmp2_;
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return result;
#line 582 "PlugsManager.c"
}


static void switchboard_plugs_manager_class_init (SwitchboardPlugsManagerClass * klass) {
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	switchboard_plugs_manager_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_type_class_add_private (klass, sizeof (SwitchboardPlugsManagerPrivate));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	G_OBJECT_CLASS (klass)->finalize = switchboard_plugs_manager_finalize;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	switchboard_plugs_manager_signals[SWITCHBOARD_PLUGS_MANAGER_PLUG_ADDED_SIGNAL] = g_signal_new ("plug_added", SWITCHBOARD_TYPE_PLUGS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SWITCHBOARD_TYPE_PLUG);
#line 595 "PlugsManager.c"
}


static void switchboard_plugs_manager_instance_init (SwitchboardPlugsManager * self) {
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	self->priv = SWITCHBOARD_PLUGS_MANAGER_GET_PRIVATE (self);
#line 602 "PlugsManager.c"
}


static void switchboard_plugs_manager_finalize (GObject * obj) {
	SwitchboardPlugsManager * self;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManager);
#line 34 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (self->priv->plugs);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	G_OBJECT_CLASS (switchboard_plugs_manager_parent_class)->finalize (obj);
#line 614 "PlugsManager.c"
}


GType switchboard_plugs_manager_get_type (void) {
	static volatile gsize switchboard_plugs_manager_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_plugs_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SwitchboardPlugsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) switchboard_plugs_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SwitchboardPlugsManager), 0, (GInstanceInitFunc) switchboard_plugs_manager_instance_init, NULL };
		GType switchboard_plugs_manager_type_id;
		switchboard_plugs_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SwitchboardPlugsManager", &g_define_type_info, 0);
		g_once_init_leave (&switchboard_plugs_manager_type_id__volatile, switchboard_plugs_manager_type_id);
	}
	return switchboard_plugs_manager_type_id__volatile;
}



