/* Switchboard.c generated by valac 0.36.4, the Vala compiler
 * generated from Switchboard.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
* Authored by: Avi Romanoff <avi@romanoff.me>
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <clutter-gtk/clutter-gtk.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <switchboard.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <unity.h>
#include <libdbusmenu-glib/client.h>
#include <libdbusmenu-glib/dbusmenu-glib.h>
#include <libdbusmenu-glib/enum-types.h>
#include <libdbusmenu-glib/menuitem-proxy.h>
#include <libdbusmenu-glib/menuitem.h>
#include <libdbusmenu-glib/server.h>
#include <libdbusmenu-glib/types.h>
#include <gio/gdesktopappinfo.h>


#define SWITCHBOARD_TYPE_WINDOW_STATE (switchboard_window_state_get_type ())

#define SWITCHBOARD_TYPE_SWITCHBOARD_APP (switchboard_switchboard_app_get_type ())
#define SWITCHBOARD_SWITCHBOARD_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp))
#define SWITCHBOARD_SWITCHBOARD_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardAppClass))
#define SWITCHBOARD_IS_SWITCHBOARD_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_SWITCHBOARD_APP))
#define SWITCHBOARD_IS_SWITCHBOARD_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_SWITCHBOARD_APP))
#define SWITCHBOARD_SWITCHBOARD_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardAppClass))

typedef struct _SwitchboardSwitchboardApp SwitchboardSwitchboardApp;
typedef struct _SwitchboardSwitchboardAppClass SwitchboardSwitchboardAppClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _SwitchboardSwitchboardAppPrivate SwitchboardSwitchboardAppPrivate;

#define SWITCHBOARD_TYPE_CATEGORY_VIEW (switchboard_category_view_get_type ())
#define SWITCHBOARD_CATEGORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_CATEGORY_VIEW, SwitchboardCategoryView))
#define SWITCHBOARD_CATEGORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_CATEGORY_VIEW, SwitchboardCategoryViewClass))
#define SWITCHBOARD_IS_CATEGORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_CATEGORY_VIEW))
#define SWITCHBOARD_IS_CATEGORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_CATEGORY_VIEW))
#define SWITCHBOARD_CATEGORY_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_CATEGORY_VIEW, SwitchboardCategoryViewClass))

typedef struct _SwitchboardCategoryView SwitchboardCategoryView;
typedef struct _SwitchboardCategoryViewClass SwitchboardCategoryViewClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block1Data Block1Data;

#define SWITCHBOARD_TYPE_SEARCH_ENTRY (switchboard_search_entry_get_type ())
typedef struct _SwitchboardSearchEntry SwitchboardSearchEntry;
#define _switchboard_search_entry_free0(var) ((var == NULL) ? NULL : (var = (switchboard_search_entry_free (var), NULL)))
typedef struct _Block2Data Block2Data;

#define SWITCHBOARD_TYPE_CATEGORY (switchboard_category_get_type ())
#define SWITCHBOARD_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_CATEGORY, SwitchboardCategory))
#define SWITCHBOARD_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_CATEGORY, SwitchboardCategoryClass))
#define SWITCHBOARD_IS_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_CATEGORY))
#define SWITCHBOARD_IS_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_CATEGORY))
#define SWITCHBOARD_CATEGORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_CATEGORY, SwitchboardCategoryClass))

typedef struct _SwitchboardCategory SwitchboardCategory;
typedef struct _SwitchboardCategoryClass SwitchboardCategoryClass;
typedef struct _Block3Data Block3Data;

typedef enum  {
	SWITCHBOARD_WINDOW_STATE_NORMAL = 0,
	SWITCHBOARD_WINDOW_STATE_MAXIMIZED = 1
} SwitchboardWindowState;

struct _SwitchboardSwitchboardApp {
	GraniteApplication parent_instance;
	SwitchboardSwitchboardAppPrivate * priv;
	SwitchboardCategoryView* category_view;
	GeeArrayList* previous_plugs;
	SwitchboardPlug* current_plug;
};

struct _SwitchboardSwitchboardAppClass {
	GraniteApplicationClass parent_class;
};

struct _SwitchboardSwitchboardAppPrivate {
	GtkWindow* main_window;
	GtkScrolledWindow* category_scrolled;
	GtkStack* stack;
	GtkHeaderBar* headerbar;
	GraniteWidgetsAlertView* alert_view;
	GtkButton* navigation_button;
	GeeLinkedList* loaded_plugs;
	gchar* all_settings_label;
	GtkSearchEntry* _search_box;
};

struct _Block1Data {
	int _ref_count_;
	SwitchboardSwitchboardApp* self;
	SwitchboardPlug* plug;
};

struct _SwitchboardSearchEntry {
	gchar* plug_name;
	gchar* ui_elements;
	gchar* open_window;
};

struct _Block2Data {
	int _ref_count_;
	SwitchboardSwitchboardApp* self;
	GSettings* settings;
};

struct _Block3Data {
	int _ref_count_;
	SwitchboardSwitchboardApp* self;
	SwitchboardPlug* plug;
};


static gpointer switchboard_switchboard_app_parent_class = NULL;
static gchar* switchboard_switchboard_app_plug_to_open;
static gchar* switchboard_switchboard_app_plug_to_open = NULL;
static gchar* switchboard_switchboard_app_open_window;
static gchar* switchboard_switchboard_app_open_window = NULL;
static gchar* switchboard_switchboard_app_link;
static gchar* switchboard_switchboard_app_link = NULL;
static gboolean switchboard_switchboard_app_opened_directly;
static gboolean switchboard_switchboard_app_opened_directly = FALSE;
static gboolean switchboard_switchboard_app_should_animate_next_transition;
static gboolean switchboard_switchboard_app_should_animate_next_transition = TRUE;
extern SwitchboardSwitchboardApp* switchboard_switchboard_app__instance;
SwitchboardSwitchboardApp* switchboard_switchboard_app__instance = NULL;

GType switchboard_window_state_get_type (void) G_GNUC_CONST;
gint switchboard_main (gchar** args, int args_length1);
GType switchboard_switchboard_app_get_type (void) G_GNUC_CONST;
SwitchboardSwitchboardApp* switchboard_switchboard_app_get_instance (void);
GType switchboard_category_view_get_type (void) G_GNUC_CONST;
#define SWITCHBOARD_SWITCHBOARD_APP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardAppPrivate))
enum  {
	SWITCHBOARD_SWITCHBOARD_APP_DUMMY_PROPERTY,
	SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX
};
static void switchboard_switchboard_app_real_open (GApplication* base, GFile** files, int files_length1, const gchar* hint);
static gchar* switchboard_switchboard_app_gcc_to_switchboard_code_name (SwitchboardSwitchboardApp* self, const gchar* gcc_name);
static void switchboard_switchboard_app_real_activate (GApplication* base);
static gboolean switchboard_switchboard_app_load_setting_path (SwitchboardSwitchboardApp* self, const gchar* setting_path, SwitchboardPlugsManager* plugsmanager);
void switchboard_switchboard_app_load_plug (SwitchboardSwitchboardApp* self, SwitchboardPlug* plug);
static void switchboard_switchboard_app_build (SwitchboardSwitchboardApp* self);
void switchboard_switchboard_app_hide_alert (SwitchboardSwitchboardApp* self);
void switchboard_switchboard_app_show_alert (SwitchboardSwitchboardApp* self, const gchar* primary_text, const gchar* secondary_text, const gchar* icon_name);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda6_ (Block1Data* _data1_);
GType switchboard_search_entry_get_type (void) G_GNUC_CONST;
SwitchboardSearchEntry* switchboard_search_entry_dup (const SwitchboardSearchEntry* self);
void switchboard_search_entry_free (SwitchboardSearchEntry* self);
void switchboard_search_entry_copy (const SwitchboardSearchEntry* self, SwitchboardSearchEntry* dest);
void switchboard_search_entry_destroy (SwitchboardSearchEntry* self);
GeeArrayList* switchboard_category_view_get_plug_search_result (SwitchboardCategoryView* self);
static gboolean __lambda7_ (Block1Data* _data1_, SwitchboardSearchEntry* entry);
static gboolean ___lambda7__gee_forall_func (gpointer g, gpointer self);
static void switchboard_switchboard_app_switch_to_plug (SwitchboardSwitchboardApp* self, SwitchboardPlug* plug);
static gboolean ___lambda6__gsource_func (gpointer self);
void switchboard_switchboard_app_update_libunity_quicklist (SwitchboardSwitchboardApp* self);
static DbusmenuMenuitem* switchboard_switchboard_app_add_quicklist_for_category (SwitchboardSwitchboardApp* self, SwitchboardPlugCategory category);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void switchboard_switchboard_app_set_search_box (SwitchboardSwitchboardApp* self, GtkSearchEntry* value);
GtkSearchEntry* switchboard_switchboard_app_get_search_box (SwitchboardSwitchboardApp* self);
SwitchboardCategoryView* switchboard_category_view_new (const gchar* plug);
SwitchboardCategoryView* switchboard_category_view_construct (GType object_type, const gchar* plug);
static void __lambda11_ (SwitchboardSwitchboardApp* self, SwitchboardPlug* plug);
static void ___lambda11__switchboard_category_view_plug_selected (SwitchboardCategoryView* _sender, SwitchboardPlug* plug, gpointer self);
void switchboard_category_view_load_default_plugs (SwitchboardCategoryView* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void switchboard_category_view_load_default_plugs_finish (SwitchboardCategoryView* self, GAsyncResult* _res_);
static void switchboard_switchboard_app_handle_navigation_button_clicked (SwitchboardSwitchboardApp* self);
static void _switchboard_switchboard_app_handle_navigation_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void __lambda12_ (SwitchboardSwitchboardApp* self);
void switchboard_category_view_filter_plugs (SwitchboardCategoryView* self, const gchar* filter);
static void ___lambda12__gtk_editable_changed (GtkEditable* _sender, gpointer self);
static gboolean __lambda13_ (SwitchboardSwitchboardApp* self, GdkEventKey* event);
void switchboard_category_view_activate_first_item (SwitchboardCategoryView* self);
static gboolean ___lambda13__gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static void __lambda14_ (SwitchboardSwitchboardApp* self);
static void ___lambda14__g_simple_action_activate (GSimpleAction* _sender, GVariant* parameter, gpointer self);
static gboolean __lambda15_ (SwitchboardSwitchboardApp* self, GdkEventButton* event);
static gboolean ___lambda15__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void switchboard_switchboard_app_shut_down (SwitchboardSwitchboardApp* self);
static void _switchboard_switchboard_app_shut_down_gtk_widget_destroy (GtkWidget* _sender, gpointer self);
static gboolean __lambda16_ (Block2Data* _data2_);
static gboolean ___lambda16__gtk_widget_delete_event (GtkWidget* _sender, GdkEventAny* event, gpointer self);
static gboolean __lambda17_ (SwitchboardSwitchboardApp* self, GdkEventKey* event);
void switchboard_category_view_grab_focus_first_icon_view (SwitchboardCategoryView* self);
static gboolean _vala_uint_array_contains (guint * stack, int stack_length, guint needle);
static gboolean ___lambda17__gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static gboolean __lambda18_ (Block2Data* _data2_, GdkEventWindowState* event);
static gboolean ___lambda18__gtk_widget_window_state_event (GtkWidget* _sender, GdkEventWindowState* event, gpointer self);
static void __lambda19_ (SwitchboardSwitchboardApp* self);
static void ___lambda19__gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self);
static gboolean switchboard_switchboard_app_switch_to_icons (SwitchboardSwitchboardApp* self);
gchar* switchboard_category_view_get_category_name (SwitchboardPlugCategory category);
GType switchboard_category_get_type (void) G_GNUC_CONST;
SwitchboardCategory* switchboard_category_view_get_personal_category (SwitchboardCategoryView* self);
GeeArrayList* switchboard_category_get_plugs (SwitchboardCategory* self);
SwitchboardCategory* switchboard_category_view_get_hardware_category (SwitchboardCategoryView* self);
SwitchboardCategory* switchboard_category_view_get_network_category (SwitchboardCategoryView* self);
SwitchboardCategory* switchboard_category_view_get_system_category (SwitchboardCategoryView* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ____lambda10_ (Block3Data* _data3_);
static void _____lambda10__dbusmenu_menuitem_item_activated (DbusmenuMenuitem* _sender, guint arg1, gpointer self);
SwitchboardSwitchboardApp* switchboard_switchboard_app_new (void);
SwitchboardSwitchboardApp* switchboard_switchboard_app_construct (GType object_type);
static GObject * switchboard_switchboard_app_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void switchboard_switchboard_app_finalize (GObject * obj);
static void _vala_switchboard_switchboard_app_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_switchboard_switchboard_app_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const guint SWITCHBOARD_SWITCHBOARD_APP_NAVIGATION_KEYS[5] = {(guint) GDK_KEY_Up, (guint) GDK_KEY_Down, (guint) GDK_KEY_Left, (guint) GDK_KEY_Right, (guint) GDK_KEY_Return};

GType switchboard_window_state_get_type (void) {
	static volatile gsize switchboard_window_state_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_window_state_type_id__volatile)) {
		static const GEnumValue values[] = {{SWITCHBOARD_WINDOW_STATE_NORMAL, "SWITCHBOARD_WINDOW_STATE_NORMAL", "normal"}, {SWITCHBOARD_WINDOW_STATE_MAXIMIZED, "SWITCHBOARD_WINDOW_STATE_MAXIMIZED", "maximized"}, {0, NULL, NULL}};
		GType switchboard_window_state_type_id;
		switchboard_window_state_type_id = g_enum_register_static ("SwitchboardWindowState", values);
		g_once_init_leave (&switchboard_window_state_type_id__volatile, switchboard_window_state_type_id);
	}
	return switchboard_window_state_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 34 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return self ? g_object_ref (self) : NULL;
#line 268 "Switchboard.c"
}


gint switchboard_main (gchar** args, int args_length1) {
	gint result = 0;
	SwitchboardSwitchboardApp* app = NULL;
	SwitchboardSwitchboardApp* _tmp0_;
	SwitchboardSwitchboardApp* _tmp1_;
	SwitchboardSwitchboardApp* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_;
#line 32 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_clutter_init (&args_length1, &args);
#line 34 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = switchboard_switchboard_app_get_instance ();
#line 34 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = _tmp0_;
#line 34 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 34 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	app = _tmp2_;
#line 35 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = args;
#line 35 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3__length1 = args_length1;
#line 35 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = granite_application_run ((GraniteApplication*) app, _tmp3_, _tmp3__length1);
#line 35 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = _tmp4_;
#line 35 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (app);
#line 35 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 303 "Switchboard.c"
}


int main (int argc, char ** argv) {
#if !GLIB_CHECK_VERSION (2,35,0)
	g_type_init ();
#endif
#line 29 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return switchboard_main (argv, argc);
#line 313 "Switchboard.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1407 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1407 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1407 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 332 "Switchboard.c"
	} else {
		const gchar* _tmp2_;
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp2_ = old;
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
#line 339 "Switchboard.c"
	}
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 345 "Switchboard.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp3_ = old;
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = replacement;
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 355 "Switchboard.c"
	}
#line 1408 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 359 "Switchboard.c"
		gchar* _tmp5_;
#line 1409 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp5_ = g_strdup (self);
#line 1409 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1409 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 367 "Switchboard.c"
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = old;
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp9_;
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_g_free0 (_tmp8_);
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		regex = _tmp10_;
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 399 "Switchboard.c"
				goto __catch0_g_regex_error;
			}
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1412 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			return NULL;
#line 408 "Switchboard.c"
		}
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp12_ = regex;
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp13_ = replacement;
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp11_ = _tmp14_;
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 424 "Switchboard.c"
				goto __catch0_g_regex_error;
			}
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			return NULL;
#line 435 "Switchboard.c"
		}
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp15_ = _tmp11_;
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp11_ = NULL;
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp15_;
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_g_free0 (_tmp11_);
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1413 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 449 "Switchboard.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
#line 1411 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1411 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1415 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1411 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 463 "Switchboard.c"
	}
	__finally0:
#line 1411 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1411 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1411 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1411 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return NULL;
#line 474 "Switchboard.c"
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1323 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1323 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 498 "Switchboard.c"
		glong _tmp4_;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 506 "Switchboard.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 518 "Switchboard.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	glong _tmp8_;
	glong _tmp14_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	gchar* _tmp22_;
#line 1333 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 542 "Switchboard.c"
		glong _tmp2_;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 548 "Switchboard.c"
	} else {
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 552 "Switchboard.c"
	}
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 556 "Switchboard.c"
		glong _tmp3_;
		glong _tmp4_;
		glong _tmp5_;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 568 "Switchboard.c"
	} else {
		gint _tmp6_;
		gint _tmp7_;
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 578 "Switchboard.c"
	}
#line 1342 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1342 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 584 "Switchboard.c"
		glong _tmp9_;
		glong _tmp10_;
		glong _tmp11_;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1344 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1344 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 598 "Switchboard.c"
	} else {
		glong _tmp12_;
		glong _tmp13_;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 608 "Switchboard.c"
	}
#line 1348 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1348 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 614 "Switchboard.c"
		glong _tmp15_;
		glong _tmp16_;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 623 "Switchboard.c"
	}
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 643 "Switchboard.c"
}


static gint string_last_index_of_char (const gchar* self, gunichar c, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_;
	gunichar _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1041 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1042 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 1042 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = c;
#line 1042 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = g_utf8_strrchr (((gchar*) self) + _tmp0_, (gssize) -1, _tmp1_);
#line 1042 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1044 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 1044 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 668 "Switchboard.c"
		gchar* _tmp4_;
#line 1045 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 1045 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 1045 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 676 "Switchboard.c"
	} else {
#line 1047 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = -1;
#line 1047 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 682 "Switchboard.c"
	}
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 1403 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1403 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1404 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1404 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1404 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1404 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 703 "Switchboard.c"
}


static void switchboard_switchboard_app_real_open (GApplication* base, GFile** files, int files_length1, const gchar* hint) {
	SwitchboardSwitchboardApp * self;
	GFile* file = NULL;
	GFile** _tmp0_;
	gint _tmp0__length1;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
#line 107 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = (SwitchboardSwitchboardApp*) base;
#line 107 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (hint != NULL);
#line 108 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = files;
#line 108 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0__length1 = files_length1;
#line 108 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = _tmp0_[0];
#line 108 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 108 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	file = _tmp2_;
#line 109 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = file;
#line 109 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp3_ == NULL) {
#line 110 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (file);
#line 110 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		return;
#line 741 "Switchboard.c"
	}
#line 113 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = file;
#line 113 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp5_ = g_file_get_uri_scheme (_tmp4_);
#line 113 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp6_ = _tmp5_;
#line 113 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp7_ = g_strcmp0 (_tmp6_, "settings") == 0;
#line 113 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (_tmp6_);
#line 113 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp7_) {
#line 755 "Switchboard.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gboolean _tmp13_;
#line 114 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp8_ = file;
#line 114 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp9_ = g_file_get_uri (_tmp8_);
#line 114 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp10_ = _tmp9_;
#line 114 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp11_ = string_replace (_tmp10_, "settings://", "");
#line 114 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_free0 (switchboard_switchboard_app_link);
#line 114 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_switchboard_app_link = _tmp11_;
#line 114 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_free0 (_tmp10_);
#line 115 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp12_ = switchboard_switchboard_app_link;
#line 115 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp13_ = g_str_has_suffix (_tmp12_, "/");
#line 115 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (_tmp13_) {
#line 782 "Switchboard.c"
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			gint _tmp16_;
			gchar* _tmp17_;
#line 116 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp14_ = switchboard_switchboard_app_link;
#line 116 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp15_ = switchboard_switchboard_app_link;
#line 116 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp16_ = string_last_index_of_char (_tmp15_, (gunichar) '/', 0);
#line 116 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp17_ = string_substring (_tmp14_, (glong) 0, (glong) _tmp16_);
#line 116 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_free0 (switchboard_switchboard_app_link);
#line 116 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_switchboard_app_link = _tmp17_;
#line 799 "Switchboard.c"
		}
	} else {
		gchar* name = NULL;
		GFile* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		gboolean _tmp21_;
#line 120 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_warning ("Switchboard.vala:120: Calling Switchboard directly is deprecated, plea" \
"se use the settings:// scheme instead");
#line 121 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp18_ = file;
#line 121 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp19_ = g_file_get_basename (_tmp18_);
#line 121 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		name = _tmp19_;
#line 122 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp20_ = name;
#line 122 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp21_ = string_contains (_tmp20_, ":");
#line 122 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (_tmp21_) {
#line 821 "Switchboard.c"
			gchar** parts = NULL;
			const gchar* _tmp22_;
			gchar** _tmp23_;
			gchar** _tmp24_;
			gint parts_length1;
			gint _parts_size_;
			gchar** _tmp25_;
			gint _tmp25__length1;
			const gchar* _tmp26_;
			gchar* _tmp27_;
			gchar** _tmp28_;
			gint _tmp28__length1;
			const gchar* _tmp29_;
			gchar* _tmp30_;
#line 123 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp22_ = name;
#line 123 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp24_ = _tmp23_ = g_strsplit (_tmp22_, ":", 0);
#line 123 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			parts = _tmp24_;
#line 123 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			parts_length1 = _vala_array_length (_tmp23_);
#line 123 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_parts_size_ = parts_length1;
#line 124 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp25_ = parts;
#line 124 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp25__length1 = parts_length1;
#line 124 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp26_ = _tmp25_[0];
#line 124 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp27_ = switchboard_switchboard_app_gcc_to_switchboard_code_name (self, _tmp26_);
#line 124 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_free0 (switchboard_switchboard_app_plug_to_open);
#line 124 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_switchboard_app_plug_to_open = _tmp27_;
#line 125 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp28_ = parts;
#line 125 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp28__length1 = parts_length1;
#line 125 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp29_ = _tmp28_[1];
#line 125 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp30_ = g_strdup (_tmp29_);
#line 125 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_free0 (switchboard_switchboard_app_open_window);
#line 125 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_switchboard_app_open_window = _tmp30_;
#line 122 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 872 "Switchboard.c"
		} else {
			const gchar* _tmp31_;
			gchar* _tmp32_;
#line 127 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp31_ = name;
#line 127 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp32_ = switchboard_switchboard_app_gcc_to_switchboard_code_name (self, _tmp31_);
#line 127 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_free0 (switchboard_switchboard_app_plug_to_open);
#line 127 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_switchboard_app_plug_to_open = _tmp32_;
#line 884 "Switchboard.c"
		}
#line 113 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_free0 (name);
#line 888 "Switchboard.c"
	}
#line 131 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_application_activate ((GApplication*) self);
#line 107 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (file);
#line 894 "Switchboard.c"
}


static void switchboard_switchboard_app_real_activate (GApplication* base) {
	SwitchboardSwitchboardApp * self;
	SwitchboardPlugsManager* plugsmanager = NULL;
	SwitchboardPlugsManager* _tmp0_;
	GSettings* setting = NULL;
	GSettings* _tmp1_;
	GVariant* mapping_dic = NULL;
	GSettings* _tmp2_;
	GVariant* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	GList* _tmp32_;
	guint _tmp33_;
	GeeLinkedList* _tmp36_;
	GeeArrayList* _tmp37_;
#line 134 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = (SwitchboardSwitchboardApp*) base;
#line 135 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = switchboard_plugs_manager_get_default ();
#line 135 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	plugsmanager = _tmp0_;
#line 136 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = g_settings_new ("org.pantheon.switchboard.preferences");
#line 136 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	setting = _tmp1_;
#line 137 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = setting;
#line 137 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = g_settings_get_value (_tmp2_, "mapping-override");
#line 137 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	mapping_dic = _tmp3_;
#line 138 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp5_ = switchboard_switchboard_app_link;
#line 138 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp5_ != NULL) {
#line 933 "Switchboard.c"
		GVariant* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_;
#line 138 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp6_ = mapping_dic;
#line 138 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp7_ = switchboard_switchboard_app_link;
#line 138 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp8_ = g_variant_lookup (_tmp6_, _tmp7_, "(ss)", &switchboard_switchboard_app_plug_to_open, &switchboard_switchboard_app_open_window, NULL);
#line 138 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp4_ = !_tmp8_;
#line 945 "Switchboard.c"
	} else {
#line 138 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp4_ = FALSE;
#line 949 "Switchboard.c"
	}
#line 138 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp4_) {
#line 953 "Switchboard.c"
		gboolean plug_found = FALSE;
		const gchar* _tmp9_;
		SwitchboardPlugsManager* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 139 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp9_ = switchboard_switchboard_app_link;
#line 139 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp10_ = plugsmanager;
#line 139 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp11_ = switchboard_switchboard_app_load_setting_path (self, _tmp9_, _tmp10_);
#line 139 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		plug_found = _tmp11_;
#line 141 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp12_ = plug_found;
#line 141 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (_tmp12_) {
#line 142 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_free0 (switchboard_switchboard_app_link);
#line 142 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_switchboard_app_link = NULL;
#line 145 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_switchboard_app_should_animate_next_transition = FALSE;
#line 146 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_switchboard_app_opened_directly = TRUE;
#line 979 "Switchboard.c"
		} else {
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 148 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp13_ = switchboard_switchboard_app_link;
#line 148 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp14_ = g_strdup_printf (_ ("Specified link '%s' does not exist, going back to the main panel"), _tmp13_);
#line 148 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp15_ = _tmp14_;
#line 148 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			g_warning ("Switchboard.vala:148: %s", _tmp15_);
#line 148 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_free0 (_tmp15_);
#line 994 "Switchboard.c"
		}
	} else {
		const gchar* _tmp16_;
#line 150 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp16_ = switchboard_switchboard_app_plug_to_open;
#line 150 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (_tmp16_ != NULL) {
#line 1002 "Switchboard.c"
			{
				GeeIterator* _plug_it = NULL;
				SwitchboardPlugsManager* _tmp17_;
				GeeCollection* _tmp18_;
				GeeCollection* _tmp19_;
				GeeIterator* _tmp20_;
				GeeIterator* _tmp21_;
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp17_ = plugsmanager;
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp18_ = switchboard_plugs_manager_get_plugs (_tmp17_);
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp19_ = _tmp18_;
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp21_ = _tmp20_;
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_g_object_unref0 (_tmp19_);
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_plug_it = _tmp21_;
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				while (TRUE) {
#line 1026 "Switchboard.c"
					GeeIterator* _tmp22_;
					gboolean _tmp23_;
					SwitchboardPlug* plug = NULL;
					GeeIterator* _tmp24_;
					gpointer _tmp25_;
					const gchar* _tmp26_;
					SwitchboardPlug* _tmp27_;
					const gchar* _tmp28_;
					const gchar* _tmp29_;
					gboolean _tmp30_;
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp22_ = _plug_it;
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp23_ = gee_iterator_next (_tmp22_);
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					if (!_tmp23_) {
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
						break;
#line 1045 "Switchboard.c"
					}
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp24_ = _plug_it;
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp25_ = gee_iterator_get (_tmp24_);
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					plug = (SwitchboardPlug*) _tmp25_;
#line 152 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp26_ = switchboard_switchboard_app_plug_to_open;
#line 152 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp27_ = plug;
#line 152 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp28_ = switchboard_plug_get_code_name (_tmp27_);
#line 152 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp29_ = _tmp28_;
#line 152 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp30_ = g_str_has_suffix (_tmp26_, _tmp29_);
#line 152 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					if (_tmp30_) {
#line 1065 "Switchboard.c"
						SwitchboardPlug* _tmp31_;
#line 153 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
						_tmp31_ = plug;
#line 153 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
						switchboard_switchboard_app_load_plug (self, _tmp31_);
#line 154 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
						_g_free0 (switchboard_switchboard_app_plug_to_open);
#line 154 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
						switchboard_switchboard_app_plug_to_open = NULL;
#line 157 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
						switchboard_switchboard_app_should_animate_next_transition = FALSE;
#line 158 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
						switchboard_switchboard_app_opened_directly = TRUE;
#line 159 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
						_g_object_unref0 (plug);
#line 159 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
						break;
#line 1083 "Switchboard.c"
					}
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_g_object_unref0 (plug);
#line 1087 "Switchboard.c"
				}
#line 151 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_g_object_unref0 (_plug_it);
#line 1091 "Switchboard.c"
			}
		}
	}
#line 165 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp32_ = gtk_application_get_windows ((GtkApplication*) self);
#line 165 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp33_ = g_list_length (_tmp32_);
#line 165 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp33_ > ((guint) 0)) {
#line 1101 "Switchboard.c"
		GList* _tmp34_;
		gconstpointer _tmp35_;
#line 166 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp34_ = gtk_application_get_windows ((GtkApplication*) self);
#line 166 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp35_ = _tmp34_->data;
#line 166 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_window_present ((GtkWindow*) _tmp35_);
#line 167 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_variant_unref0 (mapping_dic);
#line 167 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (setting);
#line 167 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (plugsmanager);
#line 167 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		return;
#line 1118 "Switchboard.c"
	}
#line 170 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp36_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 170 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->loaded_plugs);
#line 170 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->priv->loaded_plugs = _tmp36_;
#line 171 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp37_ = gee_array_list_new (SWITCHBOARD_TYPE_PLUG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 171 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->previous_plugs);
#line 171 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->previous_plugs = _tmp37_;
#line 173 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_switchboard_app_build (self);
#line 175 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_main ();
#line 134 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_variant_unref0 (mapping_dic);
#line 134 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (setting);
#line 134 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (plugsmanager);
#line 1142 "Switchboard.c"
}


void switchboard_switchboard_app_hide_alert (SwitchboardSwitchboardApp* self) {
	GtkStack* _tmp0_;
#line 178 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (self != NULL);
#line 179 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = self->priv->stack;
#line 179 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_stack_set_visible_child_full (_tmp0_, "main", GTK_STACK_TRANSITION_TYPE_NONE);
#line 1154 "Switchboard.c"
}


void switchboard_switchboard_app_show_alert (SwitchboardSwitchboardApp* self, const gchar* primary_text, const gchar* secondary_text, const gchar* icon_name) {
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	const gchar* _tmp2_;
	GraniteWidgetsAlertView* _tmp3_;
	const gchar* _tmp4_;
	GraniteWidgetsAlertView* _tmp5_;
	const gchar* _tmp6_;
	GtkStack* _tmp7_;
#line 182 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (self != NULL);
#line 182 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (primary_text != NULL);
#line 182 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (secondary_text != NULL);
#line 182 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (icon_name != NULL);
#line 183 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = self->priv->alert_view;
#line 183 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
#line 184 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = self->priv->alert_view;
#line 184 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = primary_text;
#line 184 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	granite_widgets_alert_view_set_title (_tmp1_, _tmp2_);
#line 185 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = self->priv->alert_view;
#line 185 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = secondary_text;
#line 185 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	granite_widgets_alert_view_set_description (_tmp3_, _tmp4_);
#line 186 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp5_ = self->priv->alert_view;
#line 186 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp6_ = icon_name;
#line 186 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	granite_widgets_alert_view_set_icon_name (_tmp5_, _tmp6_);
#line 187 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp7_ = self->priv->stack;
#line 187 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_stack_set_visible_child_full (_tmp7_, "alert", GTK_STACK_TRANSITION_TYPE_NONE);
#line 1201 "Switchboard.c"
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return _data1_;
#line 1210 "Switchboard.c"
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1219 "Switchboard.c"
		SwitchboardSwitchboardApp* self;
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		self = _data1_->self;
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_data1_->plug);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (self);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_slice_free (Block1Data, _data1_);
#line 1229 "Switchboard.c"
	}
}


static gboolean __lambda7_ (Block1Data* _data1_, SwitchboardSearchEntry* entry) {
	SwitchboardSwitchboardApp* self;
	gboolean result = FALSE;
	SwitchboardPlug* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	SwitchboardSearchEntry* _tmp3_;
	const gchar* _tmp4_;
#line 203 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = _data1_->self;
#line 204 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = _data1_->plug;
#line 204 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = switchboard_plug_get_display_name (_tmp0_);
#line 204 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = _tmp1_;
#line 204 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = entry;
#line 204 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = (*_tmp3_).plug_name;
#line 204 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 1256 "Switchboard.c"
		SwitchboardSearchEntry* _tmp5_;
		const gchar* _tmp6_;
		SwitchboardSearchEntry* _tmp11_;
		const gchar* _tmp12_;
		SwitchboardPlug* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 205 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp5_ = entry;
#line 205 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp6_ = (*_tmp5_).open_window;
#line 205 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (_tmp6_ == NULL) {
#line 1270 "Switchboard.c"
			SwitchboardPlug* _tmp7_;
#line 206 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp7_ = _data1_->plug;
#line 206 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_plug_search_callback (_tmp7_, "");
#line 1276 "Switchboard.c"
		} else {
			SwitchboardPlug* _tmp8_;
			SwitchboardSearchEntry* _tmp9_;
			const gchar* _tmp10_;
#line 208 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp8_ = _data1_->plug;
#line 208 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp9_ = entry;
#line 208 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp10_ = (*_tmp9_).open_window;
#line 208 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_plug_search_callback (_tmp8_, _tmp10_);
#line 1289 "Switchboard.c"
		}
#line 210 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp11_ = entry;
#line 210 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp12_ = (*_tmp11_).open_window;
#line 210 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp13_ = _data1_->plug;
#line 210 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp14_ = switchboard_plug_get_display_name (_tmp13_);
#line 210 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp15_ = _tmp14_;
#line 210 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_debug ("Switchboard.vala:210: open section:%s of plug: %s", _tmp12_, _tmp15_);
#line 211 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		result = TRUE;
#line 211 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_switchboard_search_entry_free0 (entry);
#line 211 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		return result;
#line 1309 "Switchboard.c"
	}
#line 214 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = FALSE;
#line 214 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_switchboard_search_entry_free0 (entry);
#line 214 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 1317 "Switchboard.c"
}


static gboolean ___lambda7__gee_forall_func (gpointer g, gpointer self) {
	gboolean result;
	result = __lambda7_ (self, (SwitchboardSearchEntry*) g);
#line 203 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 1326 "Switchboard.c"
}


static gboolean __lambda6_ (Block1Data* _data1_) {
	SwitchboardSwitchboardApp* self;
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
	SwitchboardPlug* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	SwitchboardCategoryView* _tmp16_;
	GeeArrayList* _tmp17_;
	GeeArrayList* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GeeArrayList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	GtkButton* _tmp29_;
	const gchar* _tmp30_;
	GtkButton* _tmp31_;
	GtkHeaderBar* _tmp32_;
	SwitchboardPlug* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	SwitchboardPlug* _tmp36_;
	SwitchboardPlug* _tmp37_;
	const gchar* _tmp38_;
	SwitchboardPlug* _tmp41_;
#line 197 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = _data1_->self;
#line 198 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = self->priv->loaded_plugs;
#line 198 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = _data1_->plug;
#line 198 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = switchboard_plug_get_code_name (_tmp1_);
#line 198 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = _tmp2_;
#line 198 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp3_);
#line 198 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (!_tmp4_) {
#line 1370 "Switchboard.c"
		GtkStack* _tmp5_;
		SwitchboardPlug* _tmp6_;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		SwitchboardPlug* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GeeLinkedList* _tmp12_;
		SwitchboardPlug* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 199 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp5_ = self->priv->stack;
#line 199 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp6_ = _data1_->plug;
#line 199 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp7_ = switchboard_plug_get_widget (_tmp6_);
#line 199 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp8_ = _tmp7_;
#line 199 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp9_ = _data1_->plug;
#line 199 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp10_ = switchboard_plug_get_code_name (_tmp9_);
#line 199 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp11_ = _tmp10_;
#line 199 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_stack_add_named (_tmp5_, _tmp8_, _tmp11_);
#line 199 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_tmp8_);
#line 200 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp12_ = self->priv->loaded_plugs;
#line 200 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp13_ = _data1_->plug;
#line 200 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp14_ = switchboard_plug_get_code_name (_tmp13_);
#line 200 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp15_ = _tmp14_;
#line 200 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp15_);
#line 1410 "Switchboard.c"
	}
#line 203 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp16_ = self->category_view;
#line 203 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp17_ = switchboard_category_view_get_plug_search_result (_tmp16_);
#line 203 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp18_ = _tmp17_;
#line 203 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp18_, ___lambda7__gee_forall_func, _data1_);
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp20_ = self->previous_plugs;
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp22_ = _tmp21_;
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp22_ == 0) {
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp19_ = TRUE;
#line 1430 "Switchboard.c"
	} else {
		GeeArrayList* _tmp23_;
		gpointer _tmp24_;
		SwitchboardPlug* _tmp25_;
		SwitchboardPlug* _tmp26_;
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp23_ = self->previous_plugs;
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, 0);
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp25_ = (SwitchboardPlug*) _tmp24_;
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp26_ = _data1_->plug;
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp19_ = _tmp25_ != _tmp26_;
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_tmp25_);
#line 1448 "Switchboard.c"
	}
#line 217 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp19_) {
#line 1452 "Switchboard.c"
		GeeArrayList* _tmp27_;
		SwitchboardPlug* _tmp28_;
#line 218 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp27_ = self->previous_plugs;
#line 218 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp28_ = _data1_->plug;
#line 218 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 1461 "Switchboard.c"
	}
#line 222 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp29_ = self->priv->navigation_button;
#line 222 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp30_ = self->priv->all_settings_label;
#line 222 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_button_set_label (_tmp29_, _tmp30_);
#line 223 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp31_ = self->priv->navigation_button;
#line 223 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_show ((GtkWidget*) _tmp31_);
#line 225 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp32_ = self->priv->headerbar;
#line 225 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp33_ = _data1_->plug;
#line 225 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp34_ = switchboard_plug_get_display_name (_tmp33_);
#line 225 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp35_ = _tmp34_;
#line 225 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_header_bar_set_title (_tmp32_, _tmp35_);
#line 226 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp36_ = _data1_->plug;
#line 226 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp37_ = _g_object_ref0 (_tmp36_);
#line 226 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->current_plug);
#line 226 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->current_plug = _tmp37_;
#line 229 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp38_ = switchboard_switchboard_app_open_window;
#line 229 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp38_ != NULL) {
#line 1495 "Switchboard.c"
		SwitchboardPlug* _tmp39_;
		const gchar* _tmp40_;
#line 230 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp39_ = _data1_->plug;
#line 230 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp40_ = switchboard_switchboard_app_open_window;
#line 230 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_plug_search_callback (_tmp39_, _tmp40_);
#line 231 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_free0 (switchboard_switchboard_app_open_window);
#line 231 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_switchboard_app_open_window = NULL;
#line 1508 "Switchboard.c"
	}
#line 234 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp41_ = _data1_->plug;
#line 234 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_switchboard_app_switch_to_plug (self, _tmp41_);
#line 235 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = FALSE;
#line 235 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 1518 "Switchboard.c"
}


static gboolean ___lambda6__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda6_ (self);
#line 197 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 1527 "Switchboard.c"
}


void switchboard_switchboard_app_load_plug (SwitchboardSwitchboardApp* self, SwitchboardPlug* plug) {
	Block1Data* _data1_;
	SwitchboardPlug* _tmp0_;
	SwitchboardPlug* _tmp1_;
	gint priority = 0;
	SwitchboardPlug* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_;
	gint _tmp6_;
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (self != NULL);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (plug != NULL);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data1_->_ref_count_ = 1;
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data1_->self = g_object_ref (self);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = plug;
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (_data1_->plug);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data1_->plug = _tmp1_;
#line 192 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	priority = G_PRIORITY_DEFAULT_IDLE;
#line 193 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = _data1_->plug;
#line 193 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = switchboard_plug_get_code_name (_tmp2_);
#line 193 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = _tmp3_;
#line 193 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp5_ = string_contains (_tmp4_, "-gcc-");
#line 193 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp5_) {
#line 194 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		priority = G_PRIORITY_LOW;
#line 1573 "Switchboard.c"
	}
#line 197 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp6_ = priority;
#line 197 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_idle_add_full (_tmp6_, ___lambda6__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	block1_data_unref (_data1_);
#line 190 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data1_ = NULL;
#line 1583 "Switchboard.c"
}


void switchboard_switchboard_app_update_libunity_quicklist (SwitchboardSwitchboardApp* self) {
	UnityLauncherEntry* launcher = NULL;
	const gchar* _tmp0_;
	UnityLauncherEntry* _tmp1_;
	DbusmenuMenuitem* quicklist = NULL;
	DbusmenuMenuitem* _tmp2_;
	DbusmenuMenuitem* personal_item = NULL;
	DbusmenuMenuitem* _tmp3_;
	DbusmenuMenuitem* _tmp4_;
	DbusmenuMenuitem* hardware_item = NULL;
	DbusmenuMenuitem* _tmp7_;
	DbusmenuMenuitem* _tmp8_;
	DbusmenuMenuitem* network_item = NULL;
	DbusmenuMenuitem* _tmp11_;
	DbusmenuMenuitem* _tmp12_;
	DbusmenuMenuitem* system_item = NULL;
	DbusmenuMenuitem* _tmp15_;
	DbusmenuMenuitem* _tmp16_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	DbusmenuMenuitem* _tmp22_;
#line 242 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (self != NULL);
#line 243 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = ((GraniteApplication*) self)->app_launcher;
#line 243 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = unity_launcher_entry_get_for_desktop_id (_tmp0_);
#line 243 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	launcher = _tmp1_;
#line 244 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = dbusmenu_menuitem_new ();
#line 244 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	quicklist = _tmp2_;
#line 246 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = switchboard_switchboard_app_add_quicklist_for_category (self, SWITCHBOARD_PLUG_CATEGORY_PERSONAL);
#line 246 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	personal_item = _tmp3_;
#line 247 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = personal_item;
#line 247 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp4_ != NULL) {
#line 1629 "Switchboard.c"
		DbusmenuMenuitem* _tmp5_;
		DbusmenuMenuitem* _tmp6_;
#line 248 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp5_ = quicklist;
#line 248 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp6_ = personal_item;
#line 248 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		dbusmenu_menuitem_child_append (_tmp5_, _tmp6_);
#line 1638 "Switchboard.c"
	}
#line 251 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp7_ = switchboard_switchboard_app_add_quicklist_for_category (self, SWITCHBOARD_PLUG_CATEGORY_HARDWARE);
#line 251 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	hardware_item = _tmp7_;
#line 252 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp8_ = hardware_item;
#line 252 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp8_ != NULL) {
#line 1648 "Switchboard.c"
		DbusmenuMenuitem* _tmp9_;
		DbusmenuMenuitem* _tmp10_;
#line 253 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp9_ = quicklist;
#line 253 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp10_ = hardware_item;
#line 253 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		dbusmenu_menuitem_child_append (_tmp9_, _tmp10_);
#line 1657 "Switchboard.c"
	}
#line 256 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp11_ = switchboard_switchboard_app_add_quicklist_for_category (self, SWITCHBOARD_PLUG_CATEGORY_NETWORK);
#line 256 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	network_item = _tmp11_;
#line 257 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp12_ = network_item;
#line 257 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp12_ != NULL) {
#line 1667 "Switchboard.c"
		DbusmenuMenuitem* _tmp13_;
		DbusmenuMenuitem* _tmp14_;
#line 258 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp13_ = quicklist;
#line 258 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp14_ = network_item;
#line 258 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		dbusmenu_menuitem_child_append (_tmp13_, _tmp14_);
#line 1676 "Switchboard.c"
	}
#line 261 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp15_ = switchboard_switchboard_app_add_quicklist_for_category (self, SWITCHBOARD_PLUG_CATEGORY_SYSTEM);
#line 261 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	system_item = _tmp15_;
#line 262 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp16_ = system_item;
#line 262 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp16_ != NULL) {
#line 1686 "Switchboard.c"
		DbusmenuMenuitem* _tmp17_;
		DbusmenuMenuitem* _tmp18_;
#line 263 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp17_ = quicklist;
#line 263 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp18_ = system_item;
#line 263 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		dbusmenu_menuitem_child_append (_tmp17_, _tmp18_);
#line 1695 "Switchboard.c"
	}
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp22_ = personal_item;
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp22_ != NULL) {
#line 1701 "Switchboard.c"
		DbusmenuMenuitem* _tmp23_;
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp23_ = hardware_item;
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp21_ = _tmp23_ != NULL;
#line 1707 "Switchboard.c"
	} else {
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp21_ = FALSE;
#line 1711 "Switchboard.c"
	}
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp21_) {
#line 1715 "Switchboard.c"
		DbusmenuMenuitem* _tmp24_;
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp24_ = network_item;
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp20_ = _tmp24_ != NULL;
#line 1721 "Switchboard.c"
	} else {
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp20_ = FALSE;
#line 1725 "Switchboard.c"
	}
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp20_) {
#line 1729 "Switchboard.c"
		DbusmenuMenuitem* _tmp25_;
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp25_ = system_item;
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp19_ = _tmp25_ != NULL;
#line 1735 "Switchboard.c"
	} else {
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp19_ = FALSE;
#line 1739 "Switchboard.c"
	}
#line 266 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp19_) {
#line 1743 "Switchboard.c"
		UnityLauncherEntry* _tmp26_;
		DbusmenuMenuitem* _tmp27_;
#line 267 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp26_ = launcher;
#line 267 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp27_ = quicklist;
#line 267 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		unity_launcher_entry_set_quicklist (_tmp26_, _tmp27_);
#line 1752 "Switchboard.c"
	}
#line 242 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (system_item);
#line 242 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (network_item);
#line 242 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (hardware_item);
#line 242 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (personal_item);
#line 242 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (quicklist);
#line 242 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (launcher);
#line 1766 "Switchboard.c"
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return _data2_;
#line 1775 "Switchboard.c"
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1784 "Switchboard.c"
		SwitchboardSwitchboardApp* self;
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		self = _data2_->self;
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_data2_->settings);
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (self);
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_slice_free (Block2Data, _data2_);
#line 1794 "Switchboard.c"
	}
}


static void __lambda11_ (SwitchboardSwitchboardApp* self, SwitchboardPlug* plug) {
	SwitchboardPlug* _tmp0_;
#line 289 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (plug != NULL);
#line 289 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = plug;
#line 289 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_switchboard_app_load_plug (self, _tmp0_);
#line 1807 "Switchboard.c"
}


static void ___lambda11__switchboard_category_view_plug_selected (SwitchboardCategoryView* _sender, SwitchboardPlug* plug, gpointer self) {
#line 289 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	__lambda11_ ((SwitchboardSwitchboardApp*) self, plug);
#line 1814 "Switchboard.c"
}


static void _switchboard_switchboard_app_handle_navigation_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 331 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_switchboard_app_handle_navigation_button_clicked ((SwitchboardSwitchboardApp*) self);
#line 1821 "Switchboard.c"
}


static void __lambda12_ (SwitchboardSwitchboardApp* self) {
	SwitchboardCategoryView* _tmp0_;
	GtkSearchEntry* _tmp1_;
	const gchar* _tmp2_;
#line 334 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = self->category_view;
#line 334 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = self->priv->_search_box;
#line 334 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
#line 334 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_category_view_filter_plugs (_tmp0_, _tmp2_);
#line 1837 "Switchboard.c"
}


static void ___lambda12__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 333 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	__lambda12_ ((SwitchboardSwitchboardApp*) self);
#line 1844 "Switchboard.c"
}


static gboolean __lambda13_ (SwitchboardSwitchboardApp* self, GdkEventKey* event) {
	gboolean result = FALSE;
	GdkEventKey* _tmp0_;
	guint _tmp1_;
#line 337 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 338 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = event;
#line 338 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = _tmp0_->keyval;
#line 338 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switch (_tmp1_) {
#line 338 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		case GDK_KEY_Return:
#line 1862 "Switchboard.c"
		{
			SwitchboardCategoryView* _tmp2_;
#line 340 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp2_ = self->category_view;
#line 340 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_category_view_activate_first_item (_tmp2_);
#line 341 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			result = TRUE;
#line 341 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			return result;
#line 1873 "Switchboard.c"
		}
#line 338 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		case GDK_KEY_Escape:
#line 1877 "Switchboard.c"
		{
			GtkSearchEntry* _tmp3_;
#line 343 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp3_ = self->priv->_search_box;
#line 343 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			gtk_entry_set_text ((GtkEntry*) _tmp3_, "");
#line 344 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			result = TRUE;
#line 344 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			return result;
#line 1888 "Switchboard.c"
		}
		default:
		{
#line 346 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			break;
#line 1894 "Switchboard.c"
		}
	}
#line 349 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = FALSE;
#line 349 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 1901 "Switchboard.c"
}


static gboolean ___lambda13__gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = __lambda13_ ((SwitchboardSwitchboardApp*) self, event);
#line 337 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 1910 "Switchboard.c"
}


static void __lambda14_ (SwitchboardSwitchboardApp* self) {
	GtkWindow* _tmp0_;
#line 357 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = self->priv->main_window;
#line 357 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 1920 "Switchboard.c"
}


static void ___lambda14__g_simple_action_activate (GSimpleAction* _sender, GVariant* parameter, gpointer self) {
#line 356 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	__lambda14_ ((SwitchboardSwitchboardApp*) self);
#line 1927 "Switchboard.c"
}


static gboolean __lambda15_ (SwitchboardSwitchboardApp* self, GdkEventButton* event) {
	gboolean result = FALSE;
	GdkEventButton* _tmp0_;
	guint _tmp1_;
#line 360 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 362 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = event;
#line 362 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = _tmp0_->button;
#line 362 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp1_ == ((guint) 8)) {
#line 1943 "Switchboard.c"
		GtkButton* _tmp2_;
#line 363 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp2_ = self->priv->navigation_button;
#line 363 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_button_clicked (_tmp2_);
#line 1949 "Switchboard.c"
	}
#line 366 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = FALSE;
#line 366 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 1955 "Switchboard.c"
}


static gboolean ___lambda15__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda15_ ((SwitchboardSwitchboardApp*) self, event);
#line 360 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 1964 "Switchboard.c"
}


static void _switchboard_switchboard_app_shut_down_gtk_widget_destroy (GtkWidget* _sender, gpointer self) {
#line 369 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_switchboard_app_shut_down ((SwitchboardSwitchboardApp*) self);
#line 1971 "Switchboard.c"
}


static gboolean __lambda16_ (Block2Data* _data2_) {
	SwitchboardSwitchboardApp* self;
	gboolean result = FALSE;
	GSettings* _tmp0_;
	gint _tmp1_;
#line 371 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = _data2_->self;
#line 372 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = _data2_->settings;
#line 372 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = g_settings_get_enum (_tmp0_, "window-state");
#line 372 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp1_ == ((gint) SWITCHBOARD_WINDOW_STATE_NORMAL)) {
#line 1988 "Switchboard.c"
		gint width = 0;
		gint height = 0;
		gint x = 0;
		gint y = 0;
		GtkWindow* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		GtkWindow* _tmp5_;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gchar** position = NULL;
		gint _tmp8_;
		gchar* _tmp9_;
		gint _tmp10_;
		gchar* _tmp11_;
		gchar** _tmp12_;
		gint position_length1;
		gint _position_size_;
		GSettings* _tmp13_;
		gint _tmp14_;
		GSettings* _tmp15_;
		gint _tmp16_;
		GSettings* _tmp17_;
		gchar** _tmp18_;
		gint _tmp18__length1;
#line 375 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp2_ = self->priv->main_window;
#line 375 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_window_get_size (_tmp2_, &_tmp3_, &_tmp4_);
#line 375 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		width = _tmp3_;
#line 375 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		height = _tmp4_;
#line 376 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp5_ = self->priv->main_window;
#line 376 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_window_get_position (_tmp5_, &_tmp6_, &_tmp7_);
#line 376 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		x = _tmp6_;
#line 376 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		y = _tmp7_;
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp8_ = x;
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp9_ = g_strdup_printf ("%i", _tmp8_);
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp10_ = y;
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp11_ = g_strdup_printf ("%i", _tmp10_);
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp12_ = g_new0 (gchar*, 2 + 1);
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp12_[0] = _tmp9_;
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp12_[1] = _tmp11_;
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		position = _tmp12_;
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		position_length1 = 2;
#line 378 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_position_size_ = position_length1;
#line 380 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp13_ = _data2_->settings;
#line 380 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp14_ = width;
#line 380 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_settings_set_int (_tmp13_, "window-width", _tmp14_);
#line 381 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp15_ = _data2_->settings;
#line 381 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp16_ = height;
#line 381 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_settings_set_int (_tmp15_, "window-height", _tmp16_);
#line 382 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp17_ = _data2_->settings;
#line 382 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp18_ = position;
#line 382 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp18__length1 = position_length1;
#line 382 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_settings_set_strv (_tmp17_, "position", _tmp18_);
#line 372 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		position = (_vala_array_free (position, position_length1, (GDestroyNotify) g_free), NULL);
#line 2072 "Switchboard.c"
	}
#line 385 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = FALSE;
#line 385 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 2078 "Switchboard.c"
}


static gboolean ___lambda16__gtk_widget_delete_event (GtkWidget* _sender, GdkEventAny* event, gpointer self) {
	gboolean result;
	result = __lambda16_ (self);
#line 371 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 2087 "Switchboard.c"
}


static gboolean _vala_uint_array_contains (guint * stack, int stack_length, guint needle) {
	int i;
#line 402 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	for (i = 0; i < stack_length; i++) {
#line 402 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (needle == stack[i]) {
#line 402 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			return TRUE;
#line 2099 "Switchboard.c"
		}
	}
#line 402 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return FALSE;
#line 2104 "Switchboard.c"
}


static gboolean __lambda17_ (SwitchboardSwitchboardApp* self, GdkEventKey* event) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GdkEventKey* _tmp1_;
	GdkModifierType _tmp2_;
	gboolean _tmp6_ = FALSE;
	GtkSearchEntry* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GdkEventKey* _tmp13_;
	guint _tmp14_;
	gboolean _tmp15_ = FALSE;
	GdkEventKey* _tmp16_;
	guint _tmp17_;
#line 388 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 390 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = event;
#line 390 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = _tmp1_->state;
#line 390 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if ((_tmp2_ & GDK_MOD1_MASK) != 0) {
#line 2130 "Switchboard.c"
		GdkEventKey* _tmp3_;
		guint _tmp4_;
#line 390 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp3_ = event;
#line 390 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp4_ = _tmp3_->keyval;
#line 390 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp0_ = _tmp4_ == ((guint) GDK_KEY_Left);
#line 2139 "Switchboard.c"
	} else {
#line 390 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp0_ = FALSE;
#line 2143 "Switchboard.c"
	}
#line 390 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp0_) {
#line 2147 "Switchboard.c"
		GtkButton* _tmp5_;
#line 391 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp5_ = self->priv->navigation_button;
#line 391 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_button_clicked (_tmp5_);
#line 392 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		result = FALSE;
#line 392 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		return result;
#line 2157 "Switchboard.c"
	}
#line 396 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp7_ = self->priv->_search_box;
#line 396 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_get ((GtkWidget*) _tmp7_, "has-focus", &_tmp8_, NULL);
#line 396 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp9_ = _tmp8_;
#line 396 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp9_) {
#line 2167 "Switchboard.c"
		GdkEventKey* _tmp10_;
		guint _tmp11_;
#line 396 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp10_ = event;
#line 396 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp11_ = _tmp10_->keyval;
#line 396 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp6_ = _tmp11_ == ((guint) GDK_KEY_Down);
#line 2176 "Switchboard.c"
	} else {
#line 396 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp6_ = FALSE;
#line 2180 "Switchboard.c"
	}
#line 396 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp6_) {
#line 2184 "Switchboard.c"
		SwitchboardCategoryView* _tmp12_;
#line 397 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp12_ = self->category_view;
#line 397 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_category_view_grab_focus_first_icon_view (_tmp12_);
#line 398 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		result = FALSE;
#line 398 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		return result;
#line 2194 "Switchboard.c"
	}
#line 402 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp13_ = event;
#line 402 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp14_ = _tmp13_->keyval;
#line 402 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_vala_uint_array_contains (SWITCHBOARD_SWITCHBOARD_APP_NAVIGATION_KEYS, G_N_ELEMENTS (SWITCHBOARD_SWITCHBOARD_APP_NAVIGATION_KEYS), _tmp14_)) {
#line 403 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		result = FALSE;
#line 403 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		return result;
#line 2206 "Switchboard.c"
	}
#line 406 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp16_ = event;
#line 406 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp17_ = _tmp16_->is_modifier;
#line 406 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp17_ == ((guint) 0)) {
#line 2214 "Switchboard.c"
		GtkSearchEntry* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 406 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp18_ = self->priv->_search_box;
#line 406 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_object_get ((GtkWidget*) _tmp18_, "has-focus", &_tmp19_, NULL);
#line 406 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp20_ = _tmp19_;
#line 406 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp15_ = !_tmp20_;
#line 2226 "Switchboard.c"
	} else {
#line 406 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp15_ = FALSE;
#line 2230 "Switchboard.c"
	}
#line 406 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp15_) {
#line 2234 "Switchboard.c"
		GtkSearchEntry* _tmp21_;
#line 407 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp21_ = self->priv->_search_box;
#line 407 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp21_);
#line 2240 "Switchboard.c"
	}
#line 409 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = FALSE;
#line 409 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 2246 "Switchboard.c"
}


static gboolean ___lambda17__gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = __lambda17_ ((SwitchboardSwitchboardApp*) self, event);
#line 388 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 2255 "Switchboard.c"
}


static gboolean __lambda18_ (Block2Data* _data2_, GdkEventWindowState* event) {
	SwitchboardSwitchboardApp* self;
	gboolean result = FALSE;
	GdkEventWindowState* _tmp0_;
	GdkWindowState _tmp1_;
#line 412 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = _data2_->self;
#line 412 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 413 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = event;
#line 413 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = _tmp0_->new_window_state;
#line 413 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp1_ == GDK_WINDOW_STATE_MAXIMIZED) {
#line 2274 "Switchboard.c"
		GSettings* _tmp2_;
#line 414 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp2_ = _data2_->settings;
#line 414 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_settings_set_enum (_tmp2_, "window-state", (gint) SWITCHBOARD_WINDOW_STATE_MAXIMIZED);
#line 2280 "Switchboard.c"
	} else {
		GSettings* _tmp3_;
#line 416 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp3_ = _data2_->settings;
#line 416 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_settings_set_enum (_tmp3_, "window-state", (gint) SWITCHBOARD_WINDOW_STATE_NORMAL);
#line 2287 "Switchboard.c"
	}
#line 419 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = FALSE;
#line 419 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 2293 "Switchboard.c"
}


static gboolean ___lambda18__gtk_widget_window_state_event (GtkWidget* _sender, GdkEventWindowState* event, gpointer self) {
	gboolean result;
	result = __lambda18_ (self, event);
#line 412 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 2302 "Switchboard.c"
}


static void __lambda19_ (SwitchboardSwitchboardApp* self) {
	gboolean _tmp0_;
#line 423 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = switchboard_switchboard_app_opened_directly;
#line 423 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp0_) {
#line 2312 "Switchboard.c"
		GtkSearchEntry* _tmp1_;
#line 424 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp1_ = self->priv->_search_box;
#line 424 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 2318 "Switchboard.c"
	}
}


static void ___lambda19__gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self) {
#line 422 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	__lambda19_ ((SwitchboardSwitchboardApp*) self);
#line 2326 "Switchboard.c"
}


static void switchboard_switchboard_app_build (SwitchboardSwitchboardApp* self) {
	Block2Data* _data2_;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkSearchEntry* _tmp3_;
	GtkSearchEntry* _tmp4_;
	GtkSearchEntry* _tmp5_;
	GtkSearchEntry* _tmp6_;
	GtkSearchEntry* _tmp7_;
	GtkHeaderBar* _tmp8_;
	GtkHeaderBar* _tmp9_;
	GtkHeaderBar* _tmp10_;
	const gchar* _tmp11_;
	GtkHeaderBar* _tmp12_;
	GtkButton* _tmp13_;
	GtkHeaderBar* _tmp14_;
	GtkSearchEntry* _tmp15_;
	const gchar* _tmp16_;
	SwitchboardCategoryView* _tmp17_;
	SwitchboardCategoryView* _tmp18_;
	SwitchboardCategoryView* _tmp19_;
	SwitchboardCategoryView* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkScrolledWindow* _tmp22_;
	SwitchboardCategoryView* _tmp23_;
	GraniteWidgetsAlertView* _tmp24_;
	GraniteWidgetsAlertView* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkStack* _tmp27_;
	GtkStack* _tmp28_;
	GtkStack* _tmp29_;
	GraniteWidgetsAlertView* _tmp30_;
	GtkStack* _tmp31_;
	GtkScrolledWindow* _tmp32_;
	GSettings* _tmp33_;
	GtkWindow* _tmp34_;
	GtkWindow* _tmp35_;
	GtkWindow* _tmp36_;
	const gchar* _tmp37_;
	GtkWindow* _tmp38_;
	const gchar* _tmp39_;
	GtkWindow* _tmp40_;
	GtkStack* _tmp41_;
	GtkWindow* _tmp42_;
	GSettings* _tmp43_;
	gint _tmp44_;
	GSettings* _tmp45_;
	gint _tmp46_;
	GtkWindow* _tmp47_;
	GtkWindow* _tmp48_;
	GtkHeaderBar* _tmp49_;
	GSettings* _tmp50_;
	gint _tmp51_;
	GtkWindow* _tmp65_;
	GtkButton* _tmp66_;
	GtkWindow* _tmp67_;
	GtkButton* _tmp68_;
	GtkSearchEntry* _tmp69_;
	GtkSearchEntry* _tmp70_;
	GSimpleAction* quit_action = NULL;
	GSimpleAction* _tmp71_;
	GSimpleAction* _tmp72_;
	GSimpleAction* _tmp73_;
	GtkWindow* _tmp74_;
	GtkWindow* _tmp75_;
	GtkWindow* _tmp76_;
	GtkWindow* _tmp77_;
	GtkWindow* _tmp78_;
	GtkWindow* _tmp79_;
	SwitchboardPlugsManager* _tmp80_;
	SwitchboardPlugsManager* _tmp81_;
	gboolean _tmp82_;
	gboolean _tmp83_;
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (self != NULL);
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data2_->_ref_count_ = 1;
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data2_->self = g_object_ref (self);
#line 273 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = (GtkButton*) gtk_button_new ();
#line 273 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_ref_sink (_tmp0_);
#line 273 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->navigation_button);
#line 273 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->priv->navigation_button = _tmp0_;
#line 274 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = self->priv->navigation_button;
#line 274 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 274 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_style_context_add_class (_tmp2_, "back-button");
#line 276 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 276 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_ref_sink (_tmp3_);
#line 276 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = _tmp3_;
#line 276 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_switchboard_app_set_search_box (self, _tmp4_);
#line 276 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (_tmp4_);
#line 277 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp5_ = self->priv->_search_box;
#line 277 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp5_, _ ("Search Settings"));
#line 278 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp6_ = self->priv->_search_box;
#line 278 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_set_margin_right ((GtkWidget*) _tmp6_, 5);
#line 279 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp7_ = self->priv->_search_box;
#line 279 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 281 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp8_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 281 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_ref_sink (_tmp8_);
#line 281 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 281 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->priv->headerbar = _tmp8_;
#line 282 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp9_ = self->priv->headerbar;
#line 282 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_header_bar_set_show_close_button (_tmp9_, TRUE);
#line 283 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp10_ = self->priv->headerbar;
#line 283 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp11_ = ((GraniteApplication*) self)->program_name;
#line 283 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_header_bar_set_title (_tmp10_, _tmp11_);
#line 284 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp12_ = self->priv->headerbar;
#line 284 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp13_ = self->priv->navigation_button;
#line 284 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_header_bar_pack_start (_tmp12_, (GtkWidget*) _tmp13_);
#line 285 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp14_ = self->priv->headerbar;
#line 285 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp15_ = self->priv->_search_box;
#line 285 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_header_bar_pack_end (_tmp14_, (GtkWidget*) _tmp15_);
#line 287 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp16_ = switchboard_switchboard_app_plug_to_open;
#line 287 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp17_ = switchboard_category_view_new (_tmp16_);
#line 287 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_ref_sink (_tmp17_);
#line 287 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->category_view);
#line 287 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->category_view = _tmp17_;
#line 288 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp18_ = self->category_view;
#line 288 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp18_, 12);
#line 289 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp19_ = self->category_view;
#line 289 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_object (_tmp19_, "plug-selected", (GCallback) ___lambda11__switchboard_category_view_plug_selected, self, 0);
#line 290 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp20_ = self->category_view;
#line 290 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_category_view_load_default_plugs (_tmp20_, NULL, NULL);
#line 292 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp21_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 292 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_ref_sink (_tmp21_);
#line 292 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->category_scrolled);
#line 292 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->priv->category_scrolled = _tmp21_;
#line 293 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp22_ = self->priv->category_scrolled;
#line 293 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp23_ = self->category_view;
#line 293 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_scrolled_window_add_with_viewport (_tmp22_, (GtkWidget*) _tmp23_);
#line 295 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp24_ = granite_widgets_alert_view_new ("", "", "");
#line 295 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_ref_sink (_tmp24_);
#line 295 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->alert_view);
#line 295 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->priv->alert_view = _tmp24_;
#line 296 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp25_ = self->priv->alert_view;
#line 296 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
#line 296 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_style_context_add_class (_tmp26_, GTK_STYLE_CLASS_DIM_LABEL);
#line 298 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp27_ = (GtkStack*) gtk_stack_new ();
#line 298 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_ref_sink (_tmp27_);
#line 298 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->stack);
#line 298 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->priv->stack = _tmp27_;
#line 299 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp28_ = self->priv->stack;
#line 299 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_stack_set_transition_type (_tmp28_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 300 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp29_ = self->priv->stack;
#line 300 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp30_ = self->priv->alert_view;
#line 300 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_stack_add_named (_tmp29_, (GtkWidget*) _tmp30_, "alert");
#line 301 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp31_ = self->priv->stack;
#line 301 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp32_ = self->priv->category_scrolled;
#line 301 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_stack_add_named (_tmp31_, (GtkWidget*) _tmp32_, "main");
#line 303 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp33_ = g_settings_new ("org.pantheon.switchboard.saved-state");
#line 303 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data2_->settings = _tmp33_;
#line 305 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp34_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL);
#line 305 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_ref_sink (_tmp34_);
#line 305 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->main_window);
#line 305 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->priv->main_window = _tmp34_;
#line 306 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp35_ = self->priv->main_window;
#line 306 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_window_set_application (_tmp35_, (GtkApplication*) self);
#line 307 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp36_ = self->priv->main_window;
#line 307 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp37_ = ((GraniteApplication*) self)->app_icon;
#line 307 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_window_set_icon_name (_tmp36_, _tmp37_);
#line 308 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp38_ = self->priv->main_window;
#line 308 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp39_ = ((GraniteApplication*) self)->program_name;
#line 308 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_window_set_title (_tmp38_, _tmp39_);
#line 309 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp40_ = self->priv->main_window;
#line 309 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp41_ = self->priv->stack;
#line 309 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp41_);
#line 310 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp42_ = self->priv->main_window;
#line 310 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp43_ = _data2_->settings;
#line 310 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp44_ = g_settings_get_int (_tmp43_, "window-width");
#line 310 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp45_ = _data2_->settings;
#line 310 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp46_ = g_settings_get_int (_tmp45_, "window-height");
#line 310 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_window_set_default_size (_tmp42_, _tmp44_, _tmp46_);
#line 311 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp47_ = self->priv->main_window;
#line 311 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp47_, 910, 640);
#line 312 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp48_ = self->priv->main_window;
#line 312 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp49_ = self->priv->headerbar;
#line 312 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_window_set_titlebar (_tmp48_, (GtkWidget*) _tmp49_);
#line 314 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp50_ = _data2_->settings;
#line 314 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp51_ = g_settings_get_enum (_tmp50_, "window-state");
#line 314 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp51_ == ((gint) SWITCHBOARD_WINDOW_STATE_MAXIMIZED)) {
#line 2614 "Switchboard.c"
		GtkWindow* _tmp52_;
#line 315 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp52_ = self->priv->main_window;
#line 315 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_window_maximize (_tmp52_);
#line 2620 "Switchboard.c"
	} else {
		gchar** position = NULL;
		GSettings* _tmp53_;
		gchar** _tmp54_;
		gchar** _tmp55_;
		gint position_length1;
		gint _position_size_;
		gchar** _tmp56_;
		gint _tmp56__length1;
#line 317 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp53_ = _data2_->settings;
#line 317 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp55_ = _tmp54_ = g_settings_get_strv (_tmp53_, "position");
#line 317 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		position = _tmp55_;
#line 317 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		position_length1 = _vala_array_length (_tmp54_);
#line 317 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_position_size_ = position_length1;
#line 318 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp56_ = position;
#line 318 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp56__length1 = position_length1;
#line 318 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (_tmp56__length1 != 2) {
#line 2646 "Switchboard.c"
			GtkWindow* _tmp57_;
#line 319 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp57_ = self->priv->main_window;
#line 319 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			g_object_set (_tmp57_, "window-position", GTK_WIN_POS_CENTER, NULL);
#line 2652 "Switchboard.c"
		} else {
			GtkWindow* _tmp58_;
			gchar** _tmp59_;
			gint _tmp59__length1;
			const gchar* _tmp60_;
			gint _tmp61_;
			gchar** _tmp62_;
			gint _tmp62__length1;
			const gchar* _tmp63_;
			gint _tmp64_;
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp58_ = self->priv->main_window;
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp59_ = position;
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp59__length1 = position_length1;
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp60_ = _tmp59_[0];
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp61_ = atoi (_tmp60_);
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp62_ = position;
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp62__length1 = position_length1;
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp63_ = _tmp62_[1];
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp64_ = atoi (_tmp63_);
#line 321 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			gtk_window_move (_tmp58_, _tmp61_, _tmp64_);
#line 2683 "Switchboard.c"
		}
#line 314 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		position = (_vala_array_free (position, position_length1, (GDestroyNotify) g_free), NULL);
#line 2687 "Switchboard.c"
	}
#line 325 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp65_ = self->priv->main_window;
#line 325 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp65_);
#line 327 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp66_ = self->priv->navigation_button;
#line 327 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_hide ((GtkWidget*) _tmp66_);
#line 329 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp67_ = self->priv->main_window;
#line 329 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_application_add_window ((GtkApplication*) self, _tmp67_);
#line 331 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp68_ = self->priv->navigation_button;
#line 331 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_object (_tmp68_, "clicked", (GCallback) _switchboard_switchboard_app_handle_navigation_button_clicked_gtk_button_clicked, self, 0);
#line 333 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp69_ = self->priv->_search_box;
#line 333 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_object ((GtkEditable*) _tmp69_, "changed", (GCallback) ___lambda12__gtk_editable_changed, self, 0);
#line 337 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp70_ = self->priv->_search_box;
#line 337 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_object ((GtkWidget*) _tmp70_, "key-press-event", (GCallback) ___lambda13__gtk_widget_key_press_event, self, 0);
#line 352 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp71_ = g_simple_action_new ("quit", NULL);
#line 352 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	quit_action = _tmp71_;
#line 353 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp72_ = quit_action;
#line 353 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp72_);
#line 354 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_application_add_accelerator ((GtkApplication*) self, "<Control>q", "app.quit", NULL);
#line 356 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp73_ = quit_action;
#line 356 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_object (_tmp73_, "activate", (GCallback) ___lambda14__g_simple_action_activate, self, 0);
#line 360 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp74_ = self->priv->main_window;
#line 360 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_object ((GtkWidget*) _tmp74_, "button-release-event", (GCallback) ___lambda15__gtk_widget_button_release_event, self, 0);
#line 369 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp75_ = self->priv->main_window;
#line 369 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_object ((GtkWidget*) _tmp75_, "destroy", (GCallback) _switchboard_switchboard_app_shut_down_gtk_widget_destroy, self, 0);
#line 371 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp76_ = self->priv->main_window;
#line 371 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_data ((GtkWidget*) _tmp76_, "delete-event", (GCallback) ___lambda16__gtk_widget_delete_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 388 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp77_ = self->priv->main_window;
#line 388 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_object ((GtkWidget*) _tmp77_, "key-press-event", (GCallback) ___lambda17__gtk_widget_key_press_event, self, 0);
#line 412 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp78_ = self->priv->main_window;
#line 412 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_data ((GtkWidget*) _tmp78_, "window-state-event", (GCallback) ___lambda18__gtk_widget_window_state_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 422 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp79_ = self->priv->main_window;
#line 422 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_signal_connect_object ((GtkWidget*) _tmp79_, "size-allocate", (GCallback) ___lambda19__gtk_widget_size_allocate, self, 0);
#line 428 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp80_ = switchboard_plugs_manager_get_default ();
#line 428 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp81_ = _tmp80_;
#line 428 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp82_ = switchboard_plugs_manager_has_plugs (_tmp81_);
#line 428 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp83_ = _tmp82_ == FALSE;
#line 428 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (_tmp81_);
#line 428 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp83_) {
#line 2763 "Switchboard.c"
		GtkSearchEntry* _tmp84_;
#line 429 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_switchboard_app_show_alert (self, _ ("No Settings Found"), _ ("Install some and re-launch Switchboard."), "dialog-warning");
#line 430 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp84_ = self->priv->_search_box;
#line 430 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp84_, FALSE);
#line 2771 "Switchboard.c"
	} else {
		GtkSearchEntry* _tmp85_;
		GtkSearchEntry* _tmp86_;
#line 432 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp85_ = self->priv->_search_box;
#line 432 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp85_, TRUE);
#line 433 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp86_ = self->priv->_search_box;
#line 433 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_object_set ((GtkWidget*) _tmp86_, "has-focus", TRUE, NULL);
#line 435 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_switchboard_app_update_libunity_quicklist (self);
#line 2785 "Switchboard.c"
	}
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (quit_action);
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	block2_data_unref (_data2_);
#line 272 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_data2_ = NULL;
#line 2793 "Switchboard.c"
}


static void switchboard_switchboard_app_shut_down (SwitchboardSwitchboardApp* self) {
	SwitchboardPlug* _tmp0_;
#line 440 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (self != NULL);
#line 441 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = self->current_plug;
#line 441 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp0_ != NULL) {
#line 2805 "Switchboard.c"
		SwitchboardPlug* _tmp1_;
#line 442 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp1_ = self->current_plug;
#line 442 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_plug_hidden (_tmp1_);
#line 2811 "Switchboard.c"
	}
#line 445 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_main_quit ();
#line 2815 "Switchboard.c"
}


static void switchboard_switchboard_app_handle_navigation_button_clicked (SwitchboardSwitchboardApp* self) {
	GtkButton* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 449 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (self != NULL);
#line 450 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = self->priv->navigation_button;
#line 450 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = gtk_button_get_label (_tmp0_);
#line 450 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = _tmp1_;
#line 450 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = self->priv->all_settings_label;
#line 450 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 2836 "Switchboard.c"
		GtkSearchEntry* _tmp4_;
		GtkButton* _tmp5_;
#line 451 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_switchboard_app_opened_directly = FALSE;
#line 452 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp4_ = self->priv->_search_box;
#line 452 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 453 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_switchboard_app_switch_to_icons (self);
#line 454 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp5_ = self->priv->navigation_button;
#line 454 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_widget_hide ((GtkWidget*) _tmp5_);
#line 2851 "Switchboard.c"
	} else {
		gboolean _tmp6_ = FALSE;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 456 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp7_ = self->previous_plugs;
#line 456 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 456 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp9_ = _tmp8_;
#line 456 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (_tmp9_ > 0) {
#line 2865 "Switchboard.c"
			GtkStack* _tmp10_;
			const gchar* _tmp11_;
#line 456 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp10_ = self->priv->stack;
#line 456 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp11_ = gtk_stack_get_visible_child_name (_tmp10_);
#line 456 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp6_ = g_strcmp0 (_tmp11_, "main") != 0;
#line 2874 "Switchboard.c"
		} else {
#line 456 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp6_ = FALSE;
#line 2878 "Switchboard.c"
		}
#line 456 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (_tmp6_) {
#line 2882 "Switchboard.c"
			SwitchboardPlug* _tmp12_;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			SwitchboardPlug* _tmp16_;
			GeeArrayList* _tmp17_;
			gpointer _tmp18_;
			SwitchboardPlug* _tmp19_;
#line 457 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp12_ = self->current_plug;
#line 457 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			if (_tmp12_ != NULL) {
#line 2894 "Switchboard.c"
				SwitchboardPlug* _tmp13_;
#line 458 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp13_ = self->current_plug;
#line 458 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				switchboard_plug_hidden (_tmp13_);
#line 2900 "Switchboard.c"
			}
#line 461 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp14_ = self->previous_plugs;
#line 461 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, 0);
#line 461 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp16_ = (SwitchboardPlug*) _tmp15_;
#line 461 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_switchboard_app_load_plug (self, _tmp16_);
#line 461 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (_tmp16_);
#line 462 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp17_ = self->previous_plugs;
#line 462 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp18_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp17_, 0);
#line 462 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp19_ = (SwitchboardPlug*) _tmp18_;
#line 462 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (_tmp19_);
#line 2920 "Switchboard.c"
		} else {
			SwitchboardPlug* _tmp20_;
#line 464 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp20_ = self->current_plug;
#line 464 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			switchboard_switchboard_app_switch_to_plug (self, _tmp20_);
#line 2927 "Switchboard.c"
		}
	}
}


static gboolean switchboard_switchboard_app_load_setting_path (SwitchboardSwitchboardApp* self, const gchar* setting_path, SwitchboardPlugsManager* plugsmanager) {
	gboolean result = FALSE;
	const gchar* _tmp23_;
	gboolean _tmp24_;
#line 470 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 470 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (setting_path != NULL, FALSE);
#line 470 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (plugsmanager != NULL, FALSE);
#line 2943 "Switchboard.c"
	{
		GeeIterator* _plug_it = NULL;
		SwitchboardPlugsManager* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp0_ = plugsmanager;
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp1_ = switchboard_plugs_manager_get_plugs (_tmp0_);
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp2_ = _tmp1_;
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp4_ = _tmp3_;
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_tmp2_);
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_plug_it = _tmp4_;
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		while (TRUE) {
#line 2967 "Switchboard.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_;
			SwitchboardPlug* plug = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeTreeMap* supported_settings = NULL;
			SwitchboardPlug* _tmp9_;
			GeeTreeMap* _tmp10_;
			GeeTreeMap* _tmp11_;
			GeeTreeMap* _tmp12_;
			GeeTreeMap* _tmp13_;
			GeeTreeMap* _tmp14_;
			const gchar* _tmp15_;
			gboolean _tmp16_;
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp5_ = _plug_it;
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			if (!_tmp6_) {
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				break;
#line 2990 "Switchboard.c"
			}
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp7_ = _plug_it;
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			plug = (SwitchboardPlug*) _tmp8_;
#line 472 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp9_ = plug;
#line 472 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp10_ = switchboard_plug_get_supported_settings (_tmp9_);
#line 472 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp11_ = _tmp10_;
#line 472 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp12_ = _g_object_ref0 (_tmp11_);
#line 472 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			supported_settings = _tmp12_;
#line 473 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp13_ = supported_settings;
#line 473 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			if (_tmp13_ == NULL) {
#line 474 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_g_object_unref0 (supported_settings);
#line 474 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_g_object_unref0 (plug);
#line 474 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				continue;
#line 3018 "Switchboard.c"
			}
#line 477 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp14_ = supported_settings;
#line 477 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp15_ = setting_path;
#line 477 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp16_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp14_, _tmp15_);
#line 477 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			if (_tmp16_) {
#line 3028 "Switchboard.c"
				SwitchboardPlug* _tmp17_;
				SwitchboardPlug* _tmp19_;
				GeeTreeMap* _tmp20_;
				const gchar* _tmp21_;
				gpointer _tmp22_;
#line 478 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp17_ = self->current_plug;
#line 478 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				if (_tmp17_ != NULL) {
#line 3038 "Switchboard.c"
					SwitchboardPlug* _tmp18_;
#line 479 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					_tmp18_ = self->current_plug;
#line 479 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
					switchboard_plug_hidden (_tmp18_);
#line 3044 "Switchboard.c"
				}
#line 482 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp19_ = plug;
#line 482 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				switchboard_switchboard_app_load_plug (self, _tmp19_);
#line 483 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp20_ = supported_settings;
#line 483 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp21_ = setting_path;
#line 483 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp22_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp20_, _tmp21_);
#line 483 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_g_free0 (switchboard_switchboard_app_open_window);
#line 483 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				switchboard_switchboard_app_open_window = (gchar*) _tmp22_;
#line 484 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = TRUE;
#line 484 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_g_object_unref0 (supported_settings);
#line 484 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_g_object_unref0 (plug);
#line 484 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_g_object_unref0 (_plug_it);
#line 484 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3070 "Switchboard.c"
			}
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (supported_settings);
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (plug);
#line 3076 "Switchboard.c"
		}
#line 471 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_plug_it);
#line 3080 "Switchboard.c"
	}
#line 489 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp23_ = setting_path;
#line 489 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp24_ = string_contains (_tmp23_, "/");
#line 489 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp24_) {
#line 3088 "Switchboard.c"
		gint last_index = 0;
		const gchar* _tmp25_;
		gint _tmp26_;
		const gchar* _tmp27_;
		gint _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		SwitchboardPlugsManager* _tmp31_;
		gboolean _tmp32_;
		gboolean _tmp33_;
#line 490 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp25_ = setting_path;
#line 490 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp26_ = string_last_index_of_char (_tmp25_, (gunichar) '/', 0);
#line 490 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		last_index = _tmp26_;
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp27_ = setting_path;
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp28_ = last_index;
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp29_ = string_substring (_tmp27_, (glong) 0, (glong) _tmp28_);
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp30_ = _tmp29_;
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp31_ = plugsmanager;
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp32_ = switchboard_switchboard_app_load_setting_path (self, _tmp30_, _tmp31_);
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp33_ = _tmp32_;
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_free0 (_tmp30_);
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		result = _tmp33_;
#line 491 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		return result;
#line 3125 "Switchboard.c"
	}
#line 494 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = FALSE;
#line 494 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 3131 "Switchboard.c"
}


static void switchboard_switchboard_app_switch_to_plug (SwitchboardSwitchboardApp* self, SwitchboardPlug* plug) {
	gboolean _tmp0_;
	gboolean _tmp6_ = FALSE;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GtkSearchEntry* _tmp26_;
	SwitchboardPlug* _tmp27_;
	GtkStack* _tmp28_;
	SwitchboardPlug* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	GtkScrolledWindow* _tmp32_;
#line 498 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (self != NULL);
#line 498 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (plug != NULL);
#line 499 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = switchboard_switchboard_app_should_animate_next_transition;
#line 499 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp0_ == FALSE) {
#line 3156 "Switchboard.c"
		GtkStack* _tmp1_;
#line 500 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp1_ = self->priv->stack;
#line 500 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_stack_set_transition_type (_tmp1_, GTK_STACK_TRANSITION_TYPE_NONE);
#line 501 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_switchboard_app_should_animate_next_transition = TRUE;
#line 3164 "Switchboard.c"
	} else {
		GtkStack* _tmp2_;
		GtkStackTransitionType _tmp3_;
		GtkStackTransitionType _tmp4_;
#line 502 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp2_ = self->priv->stack;
#line 502 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp3_ = gtk_stack_get_transition_type (_tmp2_);
#line 502 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp4_ = _tmp3_;
#line 502 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (_tmp4_ == GTK_STACK_TRANSITION_TYPE_NONE) {
#line 3177 "Switchboard.c"
			GtkStack* _tmp5_;
#line 503 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp5_ = self->priv->stack;
#line 503 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			gtk_stack_set_transition_type (_tmp5_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 3183 "Switchboard.c"
		}
	}
#line 506 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp7_ = self->previous_plugs;
#line 506 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 506 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp9_ = _tmp8_;
#line 506 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp9_ > 1) {
#line 3194 "Switchboard.c"
		GtkStack* _tmp10_;
		const gchar* _tmp11_;
#line 506 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp10_ = self->priv->stack;
#line 506 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp11_ = gtk_stack_get_visible_child_name (_tmp10_);
#line 506 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp6_ = g_strcmp0 (_tmp11_, "main") != 0;
#line 3203 "Switchboard.c"
	} else {
#line 506 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp6_ = FALSE;
#line 3207 "Switchboard.c"
	}
#line 506 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp6_) {
#line 3211 "Switchboard.c"
		GtkButton* _tmp12_;
		GeeArrayList* _tmp13_;
		gpointer _tmp14_;
		SwitchboardPlug* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		GeeArrayList* _tmp18_;
		GeeArrayList* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gpointer _tmp22_;
		SwitchboardPlug* _tmp23_;
#line 507 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp12_ = self->priv->navigation_button;
#line 507 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp13_ = self->previous_plugs;
#line 507 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, 0);
#line 507 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp15_ = (SwitchboardPlug*) _tmp14_;
#line 507 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp16_ = switchboard_plug_get_display_name (_tmp15_);
#line 507 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp17_ = _tmp16_;
#line 507 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_button_set_label (_tmp12_, _tmp17_);
#line 507 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_tmp15_);
#line 508 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp18_ = self->previous_plugs;
#line 508 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp19_ = self->previous_plugs;
#line 508 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
#line 508 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp21_ = _tmp20_;
#line 508 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp22_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp18_, _tmp21_ - 1);
#line 508 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp23_ = (SwitchboardPlug*) _tmp22_;
#line 508 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_tmp23_);
#line 3254 "Switchboard.c"
	} else {
		GtkButton* _tmp24_;
		const gchar* _tmp25_;
#line 510 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp24_ = self->priv->navigation_button;
#line 510 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp25_ = self->priv->all_settings_label;
#line 510 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		gtk_button_set_label (_tmp24_, _tmp25_);
#line 3264 "Switchboard.c"
	}
#line 513 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp26_ = self->priv->_search_box;
#line 513 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, FALSE);
#line 514 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp27_ = plug;
#line 514 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_plug_shown (_tmp27_);
#line 515 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp28_ = self->priv->stack;
#line 515 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp29_ = plug;
#line 515 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp30_ = switchboard_plug_get_code_name (_tmp29_);
#line 515 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp31_ = _tmp30_;
#line 515 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_stack_set_visible_child_name (_tmp28_, _tmp31_);
#line 516 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp32_ = self->priv->category_scrolled;
#line 516 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_hide ((GtkWidget*) _tmp32_);
#line 3288 "Switchboard.c"
}


static gboolean switchboard_switchboard_app_switch_to_icons (SwitchboardSwitchboardApp* self) {
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GtkScrolledWindow* _tmp1_;
	GtkStack* _tmp2_;
	SwitchboardPlug* _tmp3_;
	GtkHeaderBar* _tmp4_;
	const gchar* _tmp5_;
	GtkSearchEntry* _tmp6_;
	GtkSearchEntry* _tmp7_;
	SwitchboardPlugsManager* _tmp8_;
	SwitchboardPlugsManager* _tmp9_;
	gboolean _tmp10_;
	GtkSearchEntry* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
#line 519 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 520 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = self->previous_plugs;
#line 520 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 521 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = self->priv->category_scrolled;
#line 521 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_show ((GtkWidget*) _tmp1_);
#line 522 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = self->priv->stack;
#line 522 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_stack_set_visible_child_full (_tmp2_, "main", GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 523 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = self->current_plug;
#line 523 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_plug_hidden (_tmp3_);
#line 525 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = self->priv->headerbar;
#line 525 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp5_ = ((GraniteApplication*) self)->program_name;
#line 525 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_header_bar_set_title (_tmp4_, _tmp5_);
#line 527 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp6_ = self->priv->_search_box;
#line 527 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp6_, "");
#line 528 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp7_ = self->priv->_search_box;
#line 528 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp8_ = switchboard_plugs_manager_get_default ();
#line 528 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp9_ = _tmp8_;
#line 528 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp10_ = switchboard_plugs_manager_has_plugs (_tmp9_);
#line 528 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, _tmp10_);
#line 528 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (_tmp9_);
#line 530 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp11_ = self->priv->_search_box;
#line 530 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp12_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp11_);
#line 530 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp13_ = _tmp12_;
#line 530 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp13_) {
#line 3356 "Switchboard.c"
		GtkSearchEntry* _tmp14_;
#line 531 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp14_ = self->priv->_search_box;
#line 531 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_object_set ((GtkWidget*) _tmp14_, "has-focus", TRUE, NULL);
#line 3362 "Switchboard.c"
	}
#line 534 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = TRUE;
#line 534 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 3368 "Switchboard.c"
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return _data3_;
#line 3377 "Switchboard.c"
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 3386 "Switchboard.c"
		SwitchboardSwitchboardApp* self;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		self = _data3_->self;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_data3_->plug);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (self);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_slice_free (Block3Data, _data3_);
#line 3396 "Switchboard.c"
	}
}


static void ____lambda10_ (Block3Data* _data3_) {
	SwitchboardSwitchboardApp* self;
	SwitchboardPlug* _tmp0_;
#line 568 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = _data3_->self;
#line 569 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = _data3_->plug;
#line 569 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_switchboard_app_load_plug (self, _tmp0_);
#line 570 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_application_activate ((GApplication*) self);
#line 3412 "Switchboard.c"
}


static void _____lambda10__dbusmenu_menuitem_item_activated (DbusmenuMenuitem* _sender, guint arg1, gpointer self) {
#line 568 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	____lambda10_ (self);
#line 3419 "Switchboard.c"
}


static DbusmenuMenuitem* switchboard_switchboard_app_add_quicklist_for_category (SwitchboardSwitchboardApp* self, SwitchboardPlugCategory category) {
	DbusmenuMenuitem* result = NULL;
	DbusmenuMenuitem* category_item = NULL;
	DbusmenuMenuitem* _tmp0_;
	DbusmenuMenuitem* _tmp1_;
	SwitchboardPlugCategory _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GeeArrayList* plugs = NULL;
	GeeArrayList* _tmp5_;
	SwitchboardPlugCategory _tmp6_;
	gboolean empty = FALSE;
	DbusmenuMenuitem* _tmp42_ = NULL;
	gboolean _tmp43_;
	DbusmenuMenuitem* _tmp45_;
#line 538 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 540 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = dbusmenu_menuitem_new ();
#line 540 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	category_item = _tmp0_;
#line 541 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = category_item;
#line 541 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = category;
#line 541 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = switchboard_category_view_get_category_name (_tmp2_);
#line 541 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = _tmp3_;
#line 541 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	dbusmenu_menuitem_property_set (_tmp1_, DBUSMENU_MENUITEM_PROP_LABEL, _tmp4_);
#line 541 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (_tmp4_);
#line 543 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp5_ = gee_array_list_new (SWITCHBOARD_TYPE_PLUG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 543 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	plugs = _tmp5_;
#line 544 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp6_ = category;
#line 544 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switch (_tmp6_) {
#line 544 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		case SWITCHBOARD_PLUG_CATEGORY_PERSONAL:
#line 3466 "Switchboard.c"
		{
			SwitchboardCategoryView* _tmp7_;
			SwitchboardCategory* _tmp8_;
			SwitchboardCategory* _tmp9_;
			GeeArrayList* _tmp10_;
#line 546 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp7_ = self->category_view;
#line 546 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp8_ = switchboard_category_view_get_personal_category (_tmp7_);
#line 546 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp9_ = _tmp8_;
#line 546 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp10_ = switchboard_category_get_plugs (_tmp9_);
#line 546 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (plugs);
#line 546 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			plugs = _tmp10_;
#line 547 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			break;
#line 3486 "Switchboard.c"
		}
#line 544 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		case SWITCHBOARD_PLUG_CATEGORY_HARDWARE:
#line 3490 "Switchboard.c"
		{
			SwitchboardCategoryView* _tmp11_;
			SwitchboardCategory* _tmp12_;
			SwitchboardCategory* _tmp13_;
			GeeArrayList* _tmp14_;
#line 549 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp11_ = self->category_view;
#line 549 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp12_ = switchboard_category_view_get_hardware_category (_tmp11_);
#line 549 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp13_ = _tmp12_;
#line 549 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp14_ = switchboard_category_get_plugs (_tmp13_);
#line 549 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (plugs);
#line 549 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			plugs = _tmp14_;
#line 550 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			break;
#line 3510 "Switchboard.c"
		}
#line 544 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		case SWITCHBOARD_PLUG_CATEGORY_NETWORK:
#line 3514 "Switchboard.c"
		{
			SwitchboardCategoryView* _tmp15_;
			SwitchboardCategory* _tmp16_;
			SwitchboardCategory* _tmp17_;
			GeeArrayList* _tmp18_;
#line 552 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp15_ = self->category_view;
#line 552 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp16_ = switchboard_category_view_get_network_category (_tmp15_);
#line 552 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp17_ = _tmp16_;
#line 552 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp18_ = switchboard_category_get_plugs (_tmp17_);
#line 552 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (plugs);
#line 552 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			plugs = _tmp18_;
#line 553 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			break;
#line 3534 "Switchboard.c"
		}
#line 544 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		case SWITCHBOARD_PLUG_CATEGORY_SYSTEM:
#line 3538 "Switchboard.c"
		{
			SwitchboardCategoryView* _tmp19_;
			SwitchboardCategory* _tmp20_;
			SwitchboardCategory* _tmp21_;
			GeeArrayList* _tmp22_;
#line 555 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp19_ = self->category_view;
#line 555 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp20_ = switchboard_category_view_get_system_category (_tmp19_);
#line 555 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp21_ = _tmp20_;
#line 555 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp22_ = switchboard_category_get_plugs (_tmp21_);
#line 555 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (plugs);
#line 555 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			plugs = _tmp22_;
#line 556 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			break;
#line 3558 "Switchboard.c"
		}
		default:
		{
#line 558 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			result = NULL;
#line 558 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (plugs);
#line 558 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (category_item);
#line 558 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			return result;
#line 3570 "Switchboard.c"
		}
	}
#line 561 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	empty = TRUE;
#line 3575 "Switchboard.c"
	{
		GeeArrayList* _plug_list = NULL;
		GeeArrayList* _tmp23_;
		GeeArrayList* _tmp24_;
		gint _plug_size = 0;
		GeeArrayList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _plug_index = 0;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp23_ = plugs;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp24_ = _g_object_ref0 (_tmp23_);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_plug_list = _tmp24_;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp25_ = _plug_list;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp27_ = _tmp26_;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_plug_size = _tmp27_;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_plug_index = -1;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		while (TRUE) {
#line 3603 "Switchboard.c"
			Block3Data* _data3_;
			gint _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			GeeArrayList* _tmp31_;
			gint _tmp32_;
			gpointer _tmp33_;
			DbusmenuMenuitem* item = NULL;
			DbusmenuMenuitem* _tmp34_;
			DbusmenuMenuitem* _tmp35_;
			SwitchboardPlug* _tmp36_;
			const gchar* _tmp37_;
			const gchar* _tmp38_;
			DbusmenuMenuitem* _tmp39_;
			DbusmenuMenuitem* _tmp40_;
			DbusmenuMenuitem* _tmp41_;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_data3_ = g_slice_new0 (Block3Data);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_data3_->_ref_count_ = 1;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_data3_->self = g_object_ref (self);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp28_ = _plug_index;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_plug_index = _tmp28_ + 1;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp29_ = _plug_index;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp30_ = _plug_size;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			if (!(_tmp29_ < _tmp30_)) {
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				block3_data_unref (_data3_);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_data3_ = NULL;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				break;
#line 3642 "Switchboard.c"
			}
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp31_ = _plug_list;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp32_ = _plug_index;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, _tmp32_);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_data3_->plug = (SwitchboardPlug*) _tmp33_;
#line 564 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp34_ = dbusmenu_menuitem_new ();
#line 564 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			item = _tmp34_;
#line 565 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp35_ = item;
#line 565 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp36_ = _data3_->plug;
#line 565 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp37_ = switchboard_plug_get_display_name (_tmp36_);
#line 565 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp38_ = _tmp37_;
#line 565 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			dbusmenu_menuitem_property_set (_tmp35_, DBUSMENU_MENUITEM_PROP_LABEL, _tmp38_);
#line 568 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp39_ = item;
#line 568 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			g_signal_connect_data (_tmp39_, "item-activated", (GCallback) _____lambda10__dbusmenu_menuitem_item_activated, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 574 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp40_ = category_item;
#line 574 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp41_ = item;
#line 574 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			dbusmenu_menuitem_child_append (_tmp40_, _tmp41_);
#line 575 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			empty = FALSE;
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (item);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			block3_data_unref (_data3_);
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_data3_ = NULL;
#line 3684 "Switchboard.c"
		}
#line 563 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (_plug_list);
#line 3688 "Switchboard.c"
	}
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp43_ = empty;
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp43_) {
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp42_ = NULL;
#line 3696 "Switchboard.c"
	} else {
		DbusmenuMenuitem* _tmp44_;
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp44_ = category_item;
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp42_ = _tmp44_;
#line 3703 "Switchboard.c"
	}
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp45_ = _g_object_ref0 (_tmp42_);
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = _tmp45_;
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (plugs);
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (category_item);
#line 578 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 3715 "Switchboard.c"
}


static gchar* switchboard_switchboard_app_gcc_to_switchboard_code_name (SwitchboardSwitchboardApp* self, const gchar* gcc_name) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label0 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label1 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label2 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label3 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label4 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label5 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label6 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label7 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label8 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label9 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label10 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label11 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label12 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label13 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label14 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label15 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label16 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label17 = 0;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	static GQuark _tmp2_label18 = 0;
#line 582 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 582 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (gcc_name != NULL, NULL);
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = gcc_name;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = _tmp0_;
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("background")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3776 "Switchboard.c"
			default:
			{
				gchar* _tmp4_;
#line 585 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp4_ = g_strdup ("pantheon-desktop");
#line 585 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp4_;
#line 585 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3786 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("bluetooth")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3792 "Switchboard.c"
			default:
			{
				gchar* _tmp5_;
#line 586 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp5_ = g_strdup ("network-pantheon-bluetooth");
#line 586 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp5_;
#line 586 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3802 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("color")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3808 "Switchboard.c"
			default:
			{
				gchar* _tmp6_;
#line 587 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp6_ = g_strdup ("hardware-gcc-color");
#line 587 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp6_;
#line 587 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3818 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("datetime")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3824 "Switchboard.c"
			default:
			{
				gchar* _tmp7_;
#line 588 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp7_ = g_strdup ("system-pantheon-datetime");
#line 588 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp7_;
#line 588 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3834 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("display")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3840 "Switchboard.c"
			default:
			{
				gchar* _tmp8_;
#line 589 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp8_ = g_strdup ("system-pantheon-display");
#line 589 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp8_;
#line 589 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3850 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("info")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3856 "Switchboard.c"
			default:
			{
				gchar* _tmp9_;
#line 590 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp9_ = g_strdup ("system-pantheon-about");
#line 590 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp9_;
#line 590 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3866 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("keyboard")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3872 "Switchboard.c"
			default:
			{
				gchar* _tmp10_;
#line 591 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp10_ = g_strdup ("hardware-pantheon-keyboard");
#line 591 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp10_;
#line 591 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3882 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("network")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3888 "Switchboard.c"
			default:
			{
				gchar* _tmp11_;
#line 592 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp11_ = g_strdup ("pantheon-network");
#line 592 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp11_;
#line 592 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3898 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("power")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3904 "Switchboard.c"
			default:
			{
				gchar* _tmp12_;
#line 593 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp12_ = g_strdup ("system-pantheon-power");
#line 593 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp12_;
#line 593 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3914 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("printers")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3920 "Switchboard.c"
			default:
			{
				gchar* _tmp13_;
#line 594 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp13_ = g_strdup ("pantheon-printers");
#line 594 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp13_;
#line 594 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3930 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("privacy")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3936 "Switchboard.c"
			default:
			{
				gchar* _tmp14_;
#line 595 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp14_ = g_strdup ("pantheon-security-privacy");
#line 595 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp14_;
#line 595 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3946 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("region")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3952 "Switchboard.c"
			default:
			{
				gchar* _tmp15_;
#line 596 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp15_ = g_strdup ("system-pantheon-locale");
#line 596 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp15_;
#line 596 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3962 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("sharing")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3968 "Switchboard.c"
			default:
			{
				gchar* _tmp16_;
#line 597 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp16_ = g_strdup ("pantheon-sharing");
#line 597 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp16_;
#line 597 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3978 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("sound")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 3984 "Switchboard.c"
			default:
			{
				gchar* _tmp17_;
#line 598 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp17_ = g_strdup ("hardware-gcc-sound");
#line 598 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp17_;
#line 598 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 3994 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("universal-access")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 4000 "Switchboard.c"
			default:
			{
				gchar* _tmp18_;
#line 599 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp18_ = g_strdup ("pantheon-accessibility");
#line 599 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp18_;
#line 599 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 4010 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label15) ? _tmp2_label15 : (_tmp2_label15 = g_quark_from_static_string ("user-accounts")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 4016 "Switchboard.c"
			default:
			{
				gchar* _tmp19_;
#line 600 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp19_ = g_strdup ("system-pantheon-useraccounts");
#line 600 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp19_;
#line 600 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 4026 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label16) ? _tmp2_label16 : (_tmp2_label16 = g_quark_from_static_string ("wacom")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 4032 "Switchboard.c"
			default:
			{
				gchar* _tmp20_;
#line 601 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp20_ = g_strdup ("hardware-gcc-wacom");
#line 601 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp20_;
#line 601 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 4042 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label17) ? _tmp2_label17 : (_tmp2_label17 = g_quark_from_static_string ("notifications")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 4048 "Switchboard.c"
			default:
			{
				gchar* _tmp21_;
#line 602 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				_tmp21_ = g_strdup ("personal-pantheon-notifications");
#line 602 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = _tmp21_;
#line 602 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 4058 "Switchboard.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label18) ? _tmp2_label18 : (_tmp2_label18 = g_quark_from_static_string ("search")))) {
#line 584 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switch (0) {
#line 4064 "Switchboard.c"
			default:
			{
#line 606 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				result = NULL;
#line 606 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
				return result;
#line 4071 "Switchboard.c"
			}
		}
	}
#line 609 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = NULL;
#line 609 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 4079 "Switchboard.c"
}


SwitchboardSwitchboardApp* switchboard_switchboard_app_construct (GType object_type) {
	SwitchboardSwitchboardApp * self = NULL;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = (SwitchboardSwitchboardApp*) granite_application_construct (object_type);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return self;
#line 4089 "Switchboard.c"
}


SwitchboardSwitchboardApp* switchboard_switchboard_app_new (void) {
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return switchboard_switchboard_app_construct (SWITCHBOARD_TYPE_SWITCHBOARD_APP);
#line 4096 "Switchboard.c"
}


GtkSearchEntry* switchboard_switchboard_app_get_search_box (SwitchboardSwitchboardApp* self) {
	GtkSearchEntry* result;
	GtkSearchEntry* _tmp0_;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = self->priv->_search_box;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = _tmp0_;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 4111 "Switchboard.c"
}


static void switchboard_switchboard_app_set_search_box (SwitchboardSwitchboardApp* self, GtkSearchEntry* value) {
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_return_if_fail (self != NULL);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (switchboard_switchboard_app_get_search_box (self) != value) {
#line 4120 "Switchboard.c"
		GtkSearchEntry* _tmp0_;
		GtkSearchEntry* _tmp1_;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp0_ = value;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (self->priv->_search_box);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		self->priv->_search_box = _tmp1_;
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_object_notify ((GObject *) self, "search-box");
#line 4133 "Switchboard.c"
	}
}


SwitchboardSwitchboardApp* switchboard_switchboard_app_get_instance (void) {
	SwitchboardSwitchboardApp* result;
	SwitchboardSwitchboardApp* _tmp0_;
	SwitchboardSwitchboardApp* _tmp2_;
#line 100 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = switchboard_switchboard_app__instance;
#line 100 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp0_ == NULL) {
#line 4146 "Switchboard.c"
		SwitchboardSwitchboardApp* _tmp1_;
#line 101 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp1_ = switchboard_switchboard_app_new ();
#line 101 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (switchboard_switchboard_app__instance);
#line 101 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_switchboard_app__instance = _tmp1_;
#line 4154 "Switchboard.c"
	}
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = switchboard_switchboard_app__instance;
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	result = _tmp2_;
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return result;
#line 4162 "Switchboard.c"
}


static GObject * switchboard_switchboard_app_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SwitchboardSwitchboardApp * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GApplicationFlags _tmp5_;
	GApplicationFlags _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gchar* _tmp16_;
	GAppInfo* _tmp17_;
	GAppInfo* _tmp18_;
	gboolean _tmp19_;
	GError * _inner_error_ = NULL;
#line 68 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	parent_class = G_OBJECT_CLASS (switchboard_switchboard_app_parent_class);
#line 68 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 68 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
#line 69 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_application_set_application_id ((GApplication*) self, "org.pantheon.switchboard");
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = g_strdup (_ ("System Settings"));
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->program_name);
#line 70 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->program_name = _tmp0_;
#line 71 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp1_ = g_strdup ("2011-2016");
#line 71 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->app_years);
#line 71 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->app_years = _tmp1_;
#line 72 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp2_ = g_strdup ("switchboard");
#line 72 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->exec_name);
#line 72 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->exec_name = _tmp2_;
#line 73 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp3_ = ((GraniteApplication*) self)->exec_name;
#line 73 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp4_ = g_strconcat (_tmp3_, ".desktop", NULL);
#line 73 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->app_launcher);
#line 73 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->app_launcher = _tmp4_;
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp5_ = g_application_get_flags ((GApplication*) self);
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp6_ = _tmp5_;
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_application_set_flags ((GApplication*) self, _tmp6_ | G_APPLICATION_HANDLES_OPEN);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp7_ = g_strdup ("2.0");
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->build_version);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->build_version = _tmp7_;
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp8_ = g_strdup ("preferences-desktop");
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->app_icon);
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->app_icon = _tmp8_;
#line 78 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp9_ = g_strdup ("https://github.com/elementary/switchboard");
#line 78 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->main_url);
#line 78 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->main_url = _tmp9_;
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp10_ = g_strdup ("https://github.com/elementary/switchboard/issues");
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->bug_url);
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->bug_url = _tmp10_;
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp11_ = g_strdup ("https://elementaryos.stackexchange.com/questions/tagged/settings");
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->help_url);
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->help_url = _tmp11_;
#line 81 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp12_ = g_strdup ("https://l10n.elementary.io/projects/switchboard");
#line 81 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->translate_url);
#line 81 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->translate_url = _tmp12_;
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp13_ = g_strdup ("Avi Romanoff <avi@elementaryos.org>");
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp14_ = g_strdup ("Corentin Noël <tintou@mailoo.org>");
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp15_ = g_new0 (gchar*, 3 + 1);
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp15_[0] = _tmp13_;
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp15_[1] = _tmp14_;
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp15_[2] = NULL;
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->about_authors = (_vala_array_free (((GraniteApplication*) self)->about_authors, ((GraniteApplication*) self)->about_authors_length1, (GDestroyNotify) g_free), NULL);
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->about_authors = _tmp15_;
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->about_authors_length1 = 3;
#line 83 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp16_ = g_strdup (_ ("translator-credits"));
#line 83 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (((GraniteApplication*) self)->about_translators);
#line 83 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->about_translators = _tmp16_;
#line 84 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GraniteApplication*) self)->about_license_type = GTK_LICENSE_GPL_3_0;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp17_ = g_app_info_get_default_for_uri_scheme ("settings");
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp18_ = _tmp17_;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp19_ = _tmp18_ == NULL;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (_tmp18_);
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	if (_tmp19_) {
#line 4303 "Switchboard.c"
		GDesktopAppInfo* appinfo = NULL;
		const gchar* _tmp20_;
		GDesktopAppInfo* _tmp21_;
#line 87 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp20_ = ((GraniteApplication*) self)->app_launcher;
#line 87 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_tmp21_ = g_desktop_app_info_new (_tmp20_);
#line 87 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		appinfo = _tmp21_;
#line 4313 "Switchboard.c"
		{
			GDesktopAppInfo* _tmp22_;
#line 89 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp22_ = appinfo;
#line 89 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			g_app_info_set_as_default_for_type ((GAppInfo*) _tmp22_, "x-scheme-handler/settings", &_inner_error_);
#line 89 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4322 "Switchboard.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp23_;
			const gchar* _tmp24_;
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			e = _inner_error_;
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_inner_error_ = NULL;
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp23_ = e;
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_tmp24_ = _tmp23_->message;
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			g_critical ("Switchboard.vala:91: Unable to set default for the settings scheme: %s", _tmp24_);
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_error_free0 (e);
#line 4344 "Switchboard.c"
		}
		__finally1:
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			_g_object_unref0 (appinfo);
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 88 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
			g_clear_error (&_inner_error_);
#line 4355 "Switchboard.c"
		}
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		_g_object_unref0 (appinfo);
#line 4359 "Switchboard.c"
	}
#line 68 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	return obj;
#line 4363 "Switchboard.c"
}


static void switchboard_switchboard_app_class_init (SwitchboardSwitchboardAppClass * klass) {
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switchboard_switchboard_app_parent_class = g_type_class_peek_parent (klass);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_type_class_add_private (klass, sizeof (SwitchboardSwitchboardAppPrivate));
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GApplicationClass *) klass)->open = (void (*) (GApplication *, GFile**, int, const gchar*)) switchboard_switchboard_app_real_open;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication *)) switchboard_switchboard_app_real_activate;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_switchboard_switchboard_app_get_property;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_switchboard_switchboard_app_set_property;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	G_OBJECT_CLASS (klass)->constructor = switchboard_switchboard_app_constructor;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	G_OBJECT_CLASS (klass)->finalize = switchboard_switchboard_app_finalize;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX, g_param_spec_object ("search-box", "search-box", "search-box", gtk_search_entry_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 4386 "Switchboard.c"
}


static void switchboard_switchboard_app_instance_init (SwitchboardSwitchboardApp * self) {
	gchar* _tmp0_;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->priv = SWITCHBOARD_SWITCHBOARD_APP_GET_PRIVATE (self);
#line 49 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_tmp0_ = g_strdup (_ ("All Settings"));
#line 49 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self->priv->all_settings_label = _tmp0_;
#line 4398 "Switchboard.c"
}


static void switchboard_switchboard_app_finalize (GObject * obj) {
	SwitchboardSwitchboardApp * self;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
#line 39 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->main_window);
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->category_scrolled);
#line 41 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->stack);
#line 42 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 44 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->alert_view);
#line 45 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->navigation_button);
#line 46 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->category_view);
#line 48 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->loaded_plugs);
#line 49 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_free0 (self->priv->all_settings_label);
#line 51 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->previous_plugs);
#line 52 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->current_plug);
#line 53 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	_g_object_unref0 (self->priv->_search_box);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	G_OBJECT_CLASS (switchboard_switchboard_app_parent_class)->finalize (obj);
#line 4432 "Switchboard.c"
}


GType switchboard_switchboard_app_get_type (void) {
	static volatile gsize switchboard_switchboard_app_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_switchboard_app_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SwitchboardSwitchboardAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) switchboard_switchboard_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SwitchboardSwitchboardApp), 0, (GInstanceInitFunc) switchboard_switchboard_app_instance_init, NULL };
		GType switchboard_switchboard_app_type_id;
		switchboard_switchboard_app_type_id = g_type_register_static (GRANITE_TYPE_APPLICATION, "SwitchboardSwitchboardApp", &g_define_type_info, 0);
		g_once_init_leave (&switchboard_switchboard_app_type_id__volatile, switchboard_switchboard_app_type_id);
	}
	return switchboard_switchboard_app_type_id__volatile;
}


static void _vala_switchboard_switchboard_app_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SwitchboardSwitchboardApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switch (property_id) {
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		case SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX:
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		g_value_set_object (value, switchboard_switchboard_app_get_search_box (self));
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		break;
#line 4459 "Switchboard.c"
		default:
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		break;
#line 4465 "Switchboard.c"
	}
}


static void _vala_switchboard_switchboard_app_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SwitchboardSwitchboardApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
	switch (property_id) {
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		case SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX:
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		switchboard_switchboard_app_set_search_box (self, g_value_get_object (value));
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		break;
#line 4481 "Switchboard.c"
		default:
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/src/Switchboard.vala"
		break;
#line 4487 "Switchboard.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



